#include <nmosh/plugin-if.h>
#include <curl/curl.h>


MOSHEXPORT
void*
mcurl_easy_init(void){
    return curl_easy_init();
}

MOSHEXPORT
void
mcurl_easy_cleanup(void* h){
    curl_easy_cleanup(h);
}

MOSHEXPORT
int
mcurl_easy_perform(void* h){
    return curl_easy_perform(h);
}

MOSHEXPORT
int
mcurl_easy_setopt(void* h, int option, void* param){
    return curl_easy_setopt(h, option, param);
}

NMOSH_CONSTANT_BEGIN(mcurl_easy)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_VERBOSE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HEADER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_WILDCARDMATCH)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_WRITEFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_WRITEDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_READFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_READDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_IOCTLFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_IOCTLDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_SEEKFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_SEEKDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_SOCKOPTFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_SOCKOPTDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_OPENSOCKETFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_OPENSOCKETDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_CLOSESOCKETFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_CLOSESOCKETDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROGRESSFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROGRESSDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HEADERFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_WRITEHEADER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_DEBUGFUNCTION)
    NMOSH_EXPORT_SYMBOL_INT(CURLINFO_TEXT)
    NMOSH_EXPORT_SYMBOL_INT(CURLINFO_HEADER_IN)
    NMOSH_EXPORT_SYMBOL_INT(CURLINFO_HEADER_OUT)
    NMOSH_EXPORT_SYMBOL_INT(CURLINFO_DATA_IN)
    NMOSH_EXPORT_SYMBOL_INT(CURLINFO_DATA_OUT)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_DEBUGDATA)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_ERRORBUFFER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_STDERR)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_FAILONERROR)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_URL)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROTOCOLS)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_REDIR_PROTOCOLS)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXY)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXYPORT)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXYTYPE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_NOPROXY)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTPPROXYTUNNEL)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_INTERFACE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_LOCALPORT)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_LOCALPORTRANGE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_TCP_NODELAY)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_ADDRESS_SCOPE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_TCP_KEEPALIVE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_TCP_KEEPIDLE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_TCP_KEEPINTVL)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_USERPWD)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXYUSERPWD)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_USERNAME)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PASSWORD)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXYUSERNAME)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PROXYPASSWORD)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTPAUTH)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_BASIC)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_DIGEST)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_DIGEST_IE)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_GSSNEGOTIATE)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_NTLM)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_NTLM_WB)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_ANY)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_ANYSAFE)
    NMOSH_EXPORT_SYMBOL_INT(CURLAUTH_ONLY)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_AUTOREFERER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_ACCEPT_ENCODING)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_TRANSFER_ENCODING)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_FOLLOWLOCATION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_UNRESTRICTED_AUTH)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_MAXREDIRS)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_POSTREDIR)
    NMOSH_EXPORT_SYMBOL_INT(CURL_REDIR_POST_301)
    NMOSH_EXPORT_SYMBOL_INT(CURL_REDIR_POST_302)
    NMOSH_EXPORT_SYMBOL_INT(CURL_REDIR_POST_303)
    NMOSH_EXPORT_SYMBOL_INT(CURL_REDIR_POST_ALL)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_PUT)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_POST)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_POSTFIELDS)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_POSTFIELDSIZE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_POSTFIELDSIZE_LARGE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COPYPOSTFIELDS)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTPPOST)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_REFERER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_USERAGENT)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTPHEADER)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COOKIE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COOKIEFILE)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COOKIEJAR)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COOKIESESSION)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_COOKIELIST)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTPGET)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTP_VERSION)
    NMOSH_EXPORT_SYMBOL_INT(CURL_HTTP_VERSION_NONE)
    NMOSH_EXPORT_SYMBOL_INT(CURL_HTTP_VERSION_1_0)
    NMOSH_EXPORT_SYMBOL_INT(CURL_HTTP_VERSION_1_1)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_IGNORE_CONTENT_LENGTH)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTP_CONTENT_DECODING)
    NMOSH_EXPORT_SYMBOL_INT(CURLOPT_HTTP_TRANSFER_DECODING)
NMOSH_CONSTANT_END()
