/* Generated by re2c 0.13.5 on Mon Sep 22 17:56:35 2014 */
#line 1 "src/scanner.re"
/*
 * scanner.re
 *
 *   Copyright (c) 2008  Higepon(Taro Minowa)  <higepon@users.sourceforge.jp>
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Id: Reader.y 183 2008-07-04 06:19:28Z higepon $
 */
#include <stdio.h>
#include "Object.h"
#include "Pair.h"
#include "StringProcedures.h"
#include "TextualInputPort.h"
#include "TextualOutputPort.h"
#include "EqHashTable.h"
#include "ucs4string.h"
#include "ScannerHelper.h"
#include "Scanner.h"
#include "OSCompatThread.h"
#include "VM.h"
#include "MultiVMProcedures.h"

#define YYCTYPE ucs4char
#define YYCURSOR cursor_
#define YYMARKER marker_
#define YYLIMIT limit_
#define YYTOKEN token_
#define YYDEBUG(state, ch)  yydebug(state, ch)
#define YYFILL(n) fill(n)

using namespace scheme;

Scanner::Scanner() : eofP_(false),
                     buffer_(NULL),
                     cursor_(buffer_),
                     token_(buffer_),
                     limit_(buffer_),
                     marker_(buffer_),
                     bufferSize_(32)
{
}

Scanner::~Scanner()
{
}

// Since re2c greedy look-aheads,
// we need to give back read buffer to input-port.
void Scanner::emptyBuffer()
{
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();

    for (ucs4char* p = limit_ - 1; p >= cursor_; p--) {
        // special case
        if (eofP_ && p == limit_ - 1 && *p == '\0') {
            continue;
        } else {
            inputPort->unGetChar(*p);
        }
    }

    // even if port reaches EOF, we turns off this flag.
    // fill() will detect EOF.
    eofP_ = false;
    cursor_ = buffer_;
    limit_ = buffer_;
    token_ = buffer_;
    marker_ = buffer_;
}

void Scanner::fill(int n)
{
    if (eofP_) return;
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();
    const int restCharCount = limit_ - token_;
    const int tokenOffset = token_ - buffer_;

    if (buffer_ == NULL) {
        buffer_ = new(GC) ucs4char[bufferSize_];
        cursor_ = buffer_;
        limit_ = buffer_;
        token_ = buffer_;
        marker_ = buffer_;
    }

    if ((restCharCount + n) > bufferSize_) {
        ucs4char* newBuffer = new(GC) ucs4char[restCharCount + n + 1];
        bufferSize_ = restCharCount + n + 1;
        memmove(newBuffer, token_, restCharCount * sizeof(ucs4char));
        cursor_ = &newBuffer[cursor_ - buffer_];
        token_ = &newBuffer[token_ - buffer_];
        limit_ = &newBuffer[limit_ - buffer_];
        marker_ = &newBuffer[marker_ - buffer_];
        buffer_ = newBuffer;
    } else if (restCharCount > 0) {
        memmove(buffer_, token_, restCharCount * sizeof(ucs4char));
    }

    int i;
    for (i = 0; i < n; i++) {
        const ucs4char ch = inputPort->getChar();
        if (ch == EOF) {
            eofP_ = true;
            buffer_[i + restCharCount] = '\0';
            i++;
            break;
        } else {
            buffer_[i + restCharCount] = ch;
        }
//         if (!inputPort->isDataReady()) {
//             i++;
//
//             break;
//         }

    }
    const int readSize = i;
    cursor_ = cursor_ - tokenOffset;
    token_ = buffer_;
    marker_ = marker_ - tokenOffset;
    limit_ = limit_ - tokenOffset + readSize;
}

int yylex(YYSTYPE* yylval)
{
    return currentVM()->readerContext()->port()->scanner()->scan(yylval);
}

int Scanner::scan(YYSTYPE* yylval)
{
#line 228 "src/scanner.re"


    int comment_count = 0;

    for(;;)
    {

#line 164 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	if ((YYLIMIT - YYCURSOR) < 18) YYFILL(18);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy23;
					if (yych <= 0x00000008) goto yy25;
					goto yy22;
				} else {
					if (yych <= 0x0000001F) goto yy25;
					if (yych <= ' ') goto yy22;
					goto yy9;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '"') goto yy13;
					if (yych >= '$') goto yy9;
				} else {
					if (yych <= '\'') goto yy15;
					if (yych <= '(') goto yy20;
					if (yych <= ')') goto yy18;
					goto yy9;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= '+') goto yy4;
					if (yych <= ',') goto yy16;
					goto yy5;
				} else {
					if (yych <= '.') goto yy7;
					if (yych <= '/') goto yy9;
					goto yy6;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy17;
					goto yy9;
				} else {
					if (yych <= '@') goto yy8;
					if (yych <= 'Z') goto yy9;
					if (yych <= '[') goto yy20;
					goto yy12;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '`') {
					if (yych <= ']') goto yy18;
					if (yych <= '_') goto yy9;
					goto yy14;
				} else {
					if (yych <= 'z') goto yy9;
					if (yych <= '}') goto yy25;
					goto yy9;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy25;
					if (yych <= 0x00000084) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x000000A0) goto yy10;
					if (yych <= 0x0000167F) goto yy9;
					goto yy10;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy10;
					goto yy9;
				} else {
					if (yych <= 0x0000200A) goto yy10;
					if (yych <= 0x00002027) goto yy9;
					if (yych <= 0x00002029) goto yy10;
					goto yy9;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy10;
					if (yych <= 0x0000205E) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x00003000) goto yy10;
					if (yych <= 0x0000FFFF) goto yy9;
					goto yy25;
				}
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '!':	goto yy354;
	case '\'':	goto yy357;
	case '(':	goto yy352;
	case ',':	goto yy355;
	case '/':	goto yy358;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy368;
	case ';':	goto yy348;
	case 'B':
	case 'b':	goto yy364;
	case 'D':
	case 'd':	goto yy363;
	case 'E':
	case 'I':
	case 'e':
	case 'i':	goto yy361;
	case 'F':	goto yy367;
	case 'O':
	case 'o':	goto yy362;
	case 'T':	goto yy371;
	case 'X':
	case 'x':	goto yy360;
	case '\\':	goto yy365;
	case '`':	goto yy356;
	case 'f':	goto yy366;
	case 't':	goto yy370;
	case 'u':	goto yy351;
	case 'v':	goto yy350;
	case '|':	goto yy346;
	default:	goto yy3;
	}
yy3:
#line 505 "src/scanner.re"
	{
            // syntax error
            return 0;
        }
#line 312 "<stdout>"
yy4:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy3;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy3;
					goto yy66;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy3;
					goto yy66;
				} else {
					if (yych <= '\'') goto yy3;
					if (yych <= ')') goto yy66;
					goto yy3;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy314;
					goto yy3;
				} else {
					if (yych <= '9') goto yy312;
					if (yych <= ':') goto yy3;
					goto yy66;
				}
			} else {
				if (yych <= '\\') {
					if (yych == '[') goto yy66;
					goto yy3;
				} else {
					if (yych <= ']') goto yy66;
					if (yych <= 'h') goto yy3;
					goto yy310;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'n') {
					if (yych <= 'm') goto yy3;
					goto yy311;
				} else {
					if (yych == 0x00000085) goto yy66;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy66;
					goto yy3;
				} else {
					if (yych <= 0x00001680) goto yy66;
					if (yych <= 0x0000180D) goto yy3;
					goto yy66;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy3;
					goto yy66;
				} else {
					if (yych <= 0x00002027) goto yy3;
					if (yych <= 0x00002029) goto yy66;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy66;
					if (yych <= 0x0000205E) goto yy3;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy3;
				}
			}
		}
	}
yy5:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '\r') {
				if (yych <= 0x00000000) goto yy61;
				if (yych <= 0x00000008) goto yy3;
				goto yy61;
			} else {
				if (yych <= 0x0000001F) goto yy3;
				if (yych <= '&') goto yy61;
				goto yy3;
			}
		} else {
			if (yych <= '-') {
				if (yych == ',') goto yy3;
				goto yy61;
			} else {
				if (yych <= '.') goto yy188;
				if (yych <= '/') goto yy61;
				if (yych <= '9') goto yy189;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'm') {
			if (yych <= '`') {
				if (yych <= '>') goto yy186;
				if (yych <= '_') goto yy61;
				goto yy3;
			} else {
				if (yych == 'i') goto yy191;
				goto yy61;
			}
		} else {
			if (yych <= '}') {
				if (yych <= 'n') goto yy192;
				if (yych <= 'z') goto yy61;
				goto yy3;
			} else {
				if (yych == 0x0000007F) goto yy3;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy3;
			}
		}
	}
yy6:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy168;
					if (yych <= 0x00000008) goto yy3;
					goto yy168;
				} else {
					if (yych == ' ') goto yy168;
					goto yy3;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy168;
					if (yych <= '\'') goto yy3;
					goto yy168;
				} else {
					if (yych == '+') goto yy168;
					if (yych <= ',') goto yy3;
					goto yy168;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych == ';') goto yy168;
					goto yy3;
				} else {
					if (yych <= '@') goto yy168;
					if (yych <= 'C') goto yy3;
					if (yych <= 'F') goto yy168;
					goto yy3;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy168;
					if (yych <= 'R') goto yy3;
					goto yy168;
				} else {
					if (yych == '[') goto yy168;
					if (yych <= '\\') goto yy3;
					goto yy168;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy3;
					if (yych <= 'f') goto yy168;
					goto yy3;
				} else {
					if (yych <= 'l') goto yy168;
					if (yych <= 'r') goto yy3;
					goto yy168;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '|') goto yy168;
					goto yy3;
				} else {
					if (yych <= 0x00000085) goto yy168;
					if (yych == 0x000000A0) goto yy168;
					goto yy3;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy168;
					if (yych <= 0x0000180D) goto yy3;
					goto yy168;
				} else {
					if (yych <= 0x00001FFF) goto yy3;
					if (yych <= 0x0000200A) goto yy168;
					if (yych <= 0x00002027) goto yy3;
					goto yy168;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy168;
					goto yy3;
				} else {
					if (yych <= 0x0000205F) goto yy168;
					if (yych == 0x00003000) goto yy168;
					goto yy3;
				}
			}
		}
	}
yy7:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy70;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy70;
				goto yy3;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy70;
					goto yy3;
				} else {
					if (yych <= '#') goto yy70;
					if (yych <= '\'') goto yy3;
					goto yy70;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy3;
					goto yy72;
				} else {
					if (yych <= '/') goto yy3;
					if (yych <= '9') goto yy73;
					goto yy3;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy70;
					goto yy3;
				} else {
					if (yych == '\\') goto yy3;
					goto yy70;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy70;
				if (yych <= 0x0000009F) goto yy3;
				goto yy70;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy3;
					goto yy70;
				} else {
					if (yych == 0x0000180E) goto yy70;
					goto yy3;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy70;
					goto yy3;
				} else {
					if (yych <= 0x00002029) goto yy70;
					if (yych <= 0x0000202E) goto yy3;
					goto yy70;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy70;
				} else {
					if (yych == 0x00003000) goto yy70;
					goto yy3;
				}
			}
		}
	}
yy8:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy66;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy66;
				goto yy3;
			} else {
				if (yych == '!') goto yy3;
				if (yych <= '#') goto yy66;
				goto yy3;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy66;
				if (yych == ';') goto yy66;
				goto yy3;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy66;
					goto yy3;
				} else {
					if (yych <= ']') goto yy66;
					if (yych <= 0x00000084) goto yy3;
					goto yy66;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy66;
				if (yych <= 0x0000167F) goto yy3;
				goto yy66;
			} else {
				if (yych == 0x0000180E) goto yy66;
				if (yych <= 0x00001FFF) goto yy3;
				goto yy66;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy3;
				if (yych <= 0x00002029) goto yy66;
				if (yych <= 0x0000202E) goto yy3;
				goto yy66;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy3;
				}
			}
		}
	}
yy9:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy3;
			if (yych <= '\r') goto yy61;
			goto yy3;
		} else {
			if (yych == '\'') goto yy3;
			if (yych <= '+') goto yy61;
			goto yy3;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy3;
			if (yych <= 'z') goto yy61;
			goto yy3;
		} else {
			if (yych == 0x0000007F) goto yy3;
			if (yych <= 0x0000FFFF) goto yy61;
			goto yy3;
		}
	}
yy10:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy11;
			if (yych <= '\r') goto yy61;
		} else {
			if (yych == '\'') goto yy11;
			if (yych <= '+') goto yy61;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy11;
			if (yych <= 'z') goto yy61;
		} else {
			if (yych == 0x0000007F) goto yy11;
			if (yych <= 0x0000FFFF) goto yy61;
		}
	}
yy11:
#line 489 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 727 "<stdout>"
yy12:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'x') goto yy57;
	goto yy3;
yy13:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy44;
yy14:
	yych = *++YYCURSOR;
	goto yy41;
yy15:
	yych = *++YYCURSOR;
	goto yy39;
yy16:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy36;
	goto yy34;
yy17:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy27;
yy18:
	++YYCURSOR;
#line 467 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return RIGHT_PAREN;
        }
#line 759 "<stdout>"
yy20:
	++YYCURSOR;
#line 472 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return LEFT_PAREN;
        }
#line 768 "<stdout>"
yy22:
	yych = *++YYCURSOR;
	goto yy11;
yy23:
	++YYCURSOR;
#line 493 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return END_OF_FILE;
        }
#line 779 "<stdout>"
yy25:
	yych = *++YYCURSOR;
	goto yy3;
yy26:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy27:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy28:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy30:
#line 463 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 834 "<stdout>"
yy31:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych >= 0x00000001) goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy33:
	yych = *++YYCURSOR;
	goto yy30;
yy34:
	++YYCURSOR;
#line 441 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTE; }
#line 867 "<stdout>"
yy36:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 436 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTESPLICING;
        }
#line 877 "<stdout>"
yy39:
	++YYCURSOR;
#line 431 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUOTE;
        }
#line 886 "<stdout>"
yy41:
	++YYCURSOR;
#line 426 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASIQUOTE;
        }
#line 895 "<stdout>"
yy43:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy44:
	if (yych == '"') goto yy47;
	if (yych != '\\') goto yy43;
yy45:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'u') {
		if (yych <= '\\') {
			if (yych <= '\r') {
				if (yych <= '\t') {
					if (yych >= '\t') goto yy50;
				} else {
					if (yych <= '\n') goto yy52;
					if (yych >= '\r') goto yy54;
				}
			} else {
				if (yych <= '!') {
					if (yych == ' ') goto yy50;
				} else {
					if (yych <= '"') goto yy43;
					if (yych >= '\\') goto yy43;
				}
			}
		} else {
			if (yych <= 'm') {
				if (yych <= 'b') {
					if (yych >= 'a') goto yy43;
				} else {
					if (yych == 'f') goto yy43;
				}
			} else {
				if (yych <= 'r') {
					if (yych <= 'n') goto yy43;
					if (yych >= 'r') goto yy43;
				} else {
					if (yych == 't') goto yy43;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'w') {
					if (yych <= 'v') goto yy43;
				} else {
					if (yych <= 'x') goto yy49;
					if (yych >= 0x00000085) goto yy52;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy50;
				} else {
					if (yych <= 0x00001680) goto yy50;
					if (yych >= 0x0000180E) goto yy50;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych >= 0x00002000) goto yy50;
				} else {
					if (yych == 0x00002028) goto yy52;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy50;
					if (yych >= 0x0000205F) goto yy50;
				} else {
					if (yych == 0x00003000) goto yy50;
				}
			}
		}
	}
yy46:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 3) {
		if (yyaccept <= 1) {
			if (yyaccept <= 0) {
				goto yy3;
			} else {
				goto yy11;
			}
		} else {
			if (yyaccept <= 2) {
				goto yy30;
			} else {
				goto yy64;
			}
		}
	} else {
		if (yyaccept <= 5) {
			if (yyaccept <= 4) {
				goto yy78;
			} else {
				goto yy781;
			}
		} else {
			goto yy801;
		}
	}
yy47:
	++YYCURSOR;
#line 416 "src/scanner.re"
	{
            yylval->stringValue = ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN) - 2);
            YYTOKEN = YYCURSOR;
            return STRING;
        }
#line 1009 "<stdout>"
yy49:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy55;
		goto yy46;
	} else {
		if (yych <= 'F') goto yy55;
		if (yych <= '`') goto yy46;
		if (yych <= 'f') goto yy55;
		goto yy46;
	}
yy50:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00001680) {
		if (yych <= 0x0000001F) {
			if (yych <= '\n') {
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\t') goto yy50;
			} else {
				if (yych == '\r') goto yy54;
				goto yy46;
			}
		} else {
			if (yych <= 0x00000085) {
				if (yych <= ' ') goto yy50;
				if (yych <= 0x00000084) goto yy46;
			} else {
				if (yych == 0x000000A0) goto yy50;
				if (yych <= 0x0000167F) goto yy46;
				goto yy50;
			}
		}
	} else {
		if (yych <= 0x00002028) {
			if (yych <= 0x00001FFF) {
				if (yych == 0x0000180E) goto yy50;
				goto yy46;
			} else {
				if (yych <= 0x0000200A) goto yy50;
				if (yych <= 0x00002027) goto yy46;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy50;
				goto yy46;
			} else {
				if (yych <= 0x0000205F) goto yy50;
				if (yych == 0x00003000) goto yy50;
				goto yy46;
			}
		}
	}
yy52:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x0000167F) {
		if (yych <= '!') {
			if (yych <= '\t') {
				if (yych <= 0x00000008) goto yy43;
				goto yy52;
			} else {
				if (yych == ' ') goto yy52;
				goto yy43;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '"') goto yy47;
				if (yych <= '[') goto yy43;
				goto yy45;
			} else {
				if (yych == 0x000000A0) goto yy52;
				goto yy43;
			}
		}
	} else {
		if (yych <= 0x0000202E) {
			if (yych <= 0x0000180E) {
				if (yych <= 0x00001680) goto yy52;
				if (yych <= 0x0000180D) goto yy43;
				goto yy52;
			} else {
				if (yych <= 0x00001FFF) goto yy43;
				if (yych <= 0x0000200A) goto yy52;
				goto yy43;
			}
		} else {
			if (yych <= 0x0000205F) {
				if (yych <= 0x0000202F) goto yy52;
				if (yych <= 0x0000205E) goto yy43;
				goto yy52;
			} else {
				if (yych == 0x00003000) goto yy52;
				goto yy43;
			}
		}
	}
yy54:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x000000A0) {
		if (yych <= '"') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000008) goto yy43;
				if (yych <= '\n') goto yy52;
				goto yy43;
			} else {
				if (yych <= ' ') goto yy52;
				if (yych <= '!') goto yy43;
				goto yy47;
			}
		} else {
			if (yych <= 0x00000084) {
				if (yych == '\\') goto yy45;
				goto yy43;
			} else {
				if (yych <= 0x00000085) goto yy52;
				if (yych <= 0x0000009F) goto yy43;
				goto yy52;
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000180D) {
				if (yych == 0x00001680) goto yy52;
				goto yy43;
			} else {
				if (yych <= 0x0000180E) goto yy52;
				if (yych <= 0x00001FFF) goto yy43;
				goto yy52;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy52;
				goto yy43;
			} else {
				if (yych <= 0x0000205F) goto yy52;
				if (yych == 0x00003000) goto yy52;
				goto yy43;
			}
		}
	}
yy55:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy55;
		if (yych <= ':') goto yy46;
		goto yy43;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy55;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy55;
			goto yy46;
		}
	}
yy57:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy46;
	goto yy59;
yy58:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy59:
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy58;
		if (yych <= ':') goto yy46;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy58;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy58;
			goto yy46;
		}
	}
yy60:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy61:
	if (yych <= '}') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy46;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy60;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= ',') goto yy46;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x0000009F) {
				if (yych <= 0x0000007F) {
					if (yych <= '~') goto yy60;
					goto yy46;
				} else {
					if (yych != 0x00000085) goto yy60;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x000000A0) goto yy62;
					if (yych <= 0x0000167F) goto yy60;
				} else {
					if (yych != 0x0000180E) goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych >= 0x0000200B) goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy62;
					if (yych <= 0x0000202E) goto yy60;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych != 0x0000205F) goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy62:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '}') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych >= ' ') goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				} else {
					if (yych <= '\'') goto yy64;
					if (yych <= ')') goto yy66;
					goto yy60;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych >= '-') goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy64;
					if (yych <= 'z') goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x0000009F) {
				if (yych <= 0x0000007F) {
					if (yych <= '~') goto yy60;
				} else {
					if (yych == 0x00000085) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x000000A0) goto yy62;
					if (yych <= 0x0000167F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x0000180E) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy62;
					if (yych <= 0x0000202E) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
				}
			}
		}
	}
yy64:
#line 404 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
            YYTOKEN = YYCURSOR;
            return IDENTIFIER;
            }
#line 1378 "<stdout>"
yy65:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == 'x') goto yy67;
	goto yy46;
yy66:
	yych = *++YYCURSOR;
	goto yy64;
yy67:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy68;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy68:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy68;
		if (yych <= ':') goto yy46;
		goto yy60;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy68;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy68;
			goto yy46;
		}
	}
yy70:
	++YYCURSOR;
#line 421 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return DOT;
        }
#line 1427 "<stdout>"
yy72:
	yych = *++YYCURSOR;
	if (yych == '.') goto yy165;
	goto yy46;
yy73:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy73;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					if (yych <= 'C') goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych != 'L') goto yy46;
				} else {
					if (yych <= 'S') goto yy75;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 's') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
				} else {
					if (yych == 'l') goto yy75;
					if (yych <= 'r') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '|') goto yy76;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy75:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy162;
		goto yy46;
	} else {
		if (yych <= '-') goto yy162;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy163;
		goto yy46;
	}
yy76:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy160;
	goto yy46;
yy77:
	++YYCURSOR;
yy78:
#line 386 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 1549 "<stdout>"
yy79:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy121;
		if (yych <= ',') goto yy46;
		goto yy121;
	} else {
		if (yych <= '.') goto yy124;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy122;
		goto yy46;
	}
yy80:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy85;
		if (yych <= '/') goto yy46;
		goto yy83;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
		} else {
			if (yych == 'n') goto yy82;
			goto yy46;
		}
	}
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy77;
				if (yych <= 'Z') goto yy46;
				goto yy77;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'n') goto yy118;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy82:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy114;
	goto yy46;
yy83:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'C') {
			if (yych <= '.') {
				if (yych <= '-') goto yy46;
				goto yy96;
			} else {
				if (yych <= '/') goto yy98;
				if (yych <= '9') goto yy83;
				goto yy46;
			}
		} else {
			if (yych <= 'K') {
				if (yych <= 'F') goto yy97;
				goto yy46;
			} else {
				if (yych <= 'L') goto yy97;
				if (yych <= 'R') goto yy46;
				goto yy97;
			}
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'f') {
				if (yych <= 'c') goto yy46;
				goto yy97;
			} else {
				if (yych == 'i') goto yy90;
				goto yy46;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'l') goto yy97;
				if (yych <= 'r') goto yy46;
				goto yy97;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
yy85:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy86:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy86;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy46;
			} else {
				if (yych != 'S') goto yy46;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'h') {
				if (yych >= 'g') goto yy46;
			} else {
				if (yych <= 'i') goto yy90;
				if (yych <= 'k') goto yy46;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy46;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy93;
		goto yy46;
	} else {
		if (yych <= '-') goto yy93;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy94;
		goto yy46;
	}
yy89:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy91;
	goto yy46;
yy90:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy77;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy77;
				if (yych == ';') goto yy77;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy77;
				if (yych <= 0x0000167F) goto yy46;
				goto yy77;
			} else {
				if (yych == 0x0000180E) goto yy77;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy77;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy91:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy91;
	if (yych == 'i') goto yy90;
	goto yy46;
yy93:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy94:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy94;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy96:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy105;
			if (yych <= 'F') goto yy106;
			goto yy105;
		} else {
			if (yych <= 'L') goto yy106;
			if (yych <= 'R') goto yy105;
			goto yy106;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy105;
			if (yych <= 'f') goto yy106;
			goto yy105;
		} else {
			if (yych <= 'l') goto yy106;
			if (yych == 's') goto yy106;
			goto yy105;
		}
	}
yy97:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy101;
		goto yy46;
	} else {
		if (yych <= '-') goto yy101;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy102;
		goto yy46;
	}
yy98:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy99:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy99;
	if (yych == 'i') goto yy90;
	goto yy46;
yy101:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy102:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy102;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy104:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy105:
	if (yych <= 'c') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy104;
			if (yych <= 'C') goto yy46;
			goto yy110;
		} else {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy46;
				goto yy110;
			} else {
				if (yych == 'S') goto yy110;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'h') {
				if (yych <= 'f') goto yy110;
				goto yy46;
			} else {
				if (yych <= 'i') goto yy90;
				if (yych <= 'k') goto yy46;
				goto yy110;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy46;
				goto yy110;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
yy106:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy107;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy108;
		goto yy46;
	}
yy107:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy108:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy108;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy110:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy111;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy112;
		goto yy46;
	}
yy111:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy112:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy112;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy114:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy117:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy90;
	goto yy46;
yy118:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy117;
	goto yy46;
yy121:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy124;
		if (yych <= '/') goto yy46;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy153;
		} else {
			if (yych == 'n') goto yy152;
			goto yy46;
		}
	}
yy122:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy134;
					if (yych <= '/') goto yy136;
					goto yy122;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'C') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'F') goto yy135;
					if (yych <= 'K') goto yy46;
					goto yy135;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == 'S') goto yy135;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					if (yych <= ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy135;
					if (yych <= 'k') goto yy46;
					goto yy135;
				} else {
					if (yych == 's') goto yy135;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= '|') goto yy128;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy124:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy125:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= ':') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy125;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy77;
					if (yych <= 'C') goto yy46;
				} else {
					if (yych != 'L') goto yy46;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'S') goto yy127;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					if (yych <= 'c') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '|') {
				if (yych <= 'r') {
					if (yych != 'l') goto yy46;
				} else {
					if (yych <= 's') goto yy127;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy127:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy131;
		goto yy46;
	} else {
		if (yych <= '-') goto yy131;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy132;
		goto yy46;
	}
yy128:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy129:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy129;
				if (yych <= ':') goto yy46;
				goto yy77;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy131:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy132:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '|') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '/') goto yy46;
					goto yy132;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy134:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy143;
			if (yych <= 'F') goto yy144;
			goto yy143;
		} else {
			if (yych <= 'L') goto yy144;
			if (yych <= 'R') goto yy143;
			goto yy144;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy143;
			if (yych <= 'f') goto yy144;
			goto yy143;
		} else {
			if (yych <= 'l') goto yy144;
			if (yych == 's') goto yy144;
			goto yy143;
		}
	}
yy135:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy139;
		goto yy46;
	} else {
		if (yych <= '-') goto yy139;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy140;
		goto yy46;
	}
yy136:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy137:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy137;
				if (yych <= ':') goto yy46;
				goto yy77;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy139:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy140:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '|') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '/') goto yy46;
					goto yy140;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy142:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy143:
	if (yych <= 'f') {
		if (yych <= ':') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy142;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy77;
					if (yych <= 'C') goto yy46;
					goto yy148;
				} else {
					if (yych == 'L') goto yy148;
					goto yy46;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'S') goto yy148;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					if (yych <= 'c') goto yy46;
					goto yy148;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '|') {
				if (yych <= 'r') {
					if (yych == 'l') goto yy148;
					goto yy46;
				} else {
					if (yych <= 's') goto yy148;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy144:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy145;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy146;
		goto yy46;
	}
yy145:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy146:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '|') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '/') goto yy46;
					goto yy146;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy148:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy149;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy150;
		goto yy46;
	}
yy149:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy150:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '|') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '/') goto yy46;
					goto yy150;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy152:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy157;
	goto yy46;
yy153:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy90;
	goto yy46;
yy157:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy90;
	goto yy46;
yy160:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '/') goto yy46;
					goto yy160;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy162:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy163:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy163;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '{') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= '|') goto yy76;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy165:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy66;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy66;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy66;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy66;
				if (yych == ';') goto yy66;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy66;
					goto yy46;
				} else {
					if (yych <= ']') goto yy66;
					if (yych <= 0x00000084) goto yy46;
					goto yy66;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy66;
				if (yych <= 0x0000167F) goto yy46;
				goto yy66;
			} else {
				if (yych == 0x0000180E) goto yy66;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy66;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy66;
				if (yych <= 0x0000202E) goto yy46;
				goto yy66;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy46;
				}
			}
		}
	}
yy166:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy177;
			if (yych <= 'F') goto yy178;
			goto yy177;
		} else {
			if (yych <= 'L') goto yy178;
			if (yych <= 'R') goto yy177;
			goto yy178;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy177;
			if (yych <= 'f') goto yy178;
			goto yy177;
		} else {
			if (yych <= 'l') goto yy178;
			if (yych == 's') goto yy178;
			goto yy177;
		}
	}
yy167:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
yy168:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy166;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy170;
					if (yych <= '9') goto yy167;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy169;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy169;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy169;
					if (yych != 'l') goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy169;
					if (yych <= '{') goto yy46;
					goto yy76;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy169:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy173;
		goto yy46;
	} else {
		if (yych <= '-') goto yy173;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy174;
		goto yy46;
	}
yy170:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy171:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '/') goto yy46;
					goto yy171;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy173:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy174:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy174;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '{') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= '|') goto yy76;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy176:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy177:
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy176;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					if (yych <= 'C') goto yy46;
					goto yy182;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy182;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy182;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 's') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
					goto yy182;
				} else {
					if (yych == 'l') goto yy182;
					if (yych <= 'r') goto yy46;
					goto yy182;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '|') goto yy76;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy178:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy179;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy180;
		goto yy46;
	}
yy179:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy180:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy180;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '{') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= '|') goto yy76;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy182:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy183;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy184;
		goto yy46;
	}
yy183:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy184:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy184;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '{') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= '|') goto yy76;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy186:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '}') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy46;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy186;
					if (yych <= '#') goto yy66;
					goto yy186;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy186;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= ',') goto yy46;
					goto yy186;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy186;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy306;
					if (yych <= ']') goto yy66;
					goto yy186;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy186;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x0000009F) {
				if (yych <= 0x0000007F) {
					if (yych <= '~') goto yy186;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy304;
					goto yy186;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x000000A0) goto yy304;
					if (yych <= 0x0000167F) goto yy186;
					goto yy304;
				} else {
					if (yych == 0x0000180E) goto yy304;
					goto yy186;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00002029) goto yy304;
					if (yych <= 0x0000202E) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00003000) goto yy304;
					if (yych <= 0x0000FFFF) goto yy186;
					goto yy46;
				}
			}
		}
	}
yy188:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych <= '9') goto yy298;
	goto yy61;
yy189:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 10) YYFILL(10);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy277;
					goto yy280;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy189;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= '@') goto yy199;
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy278;
					goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy278;
					if (yych == 'S') goto yy278;
					goto yy60;
				} else {
					if (yych <= '\\') {
						if (yych <= '[') goto yy197;
						goto yy65;
					} else {
						if (yych <= ']') goto yy197;
						if (yych <= '_') goto yy60;
						goto yy46;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy278;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych == 'l') goto yy278;
					if (yych <= 'r') goto yy60;
					goto yy278;
				}
			} else {
				if (yych <= '}') {
					if (yych <= 'z') goto yy60;
					if (yych == '|') goto yy279;
					goto yy46;
				} else {
					if (yych <= 0x0000007F) {
						if (yych <= '~') goto yy60;
						goto yy46;
					} else {
						if (yych == 0x00000085) goto yy198;
						goto yy60;
					}
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy191:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy197;
					goto yy61;
				} else {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy197;
				if (yych <= 'Z') goto yy61;
				goto yy197;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy61;
					goto yy197;
				} else {
					if (yych == 'n') goto yy274;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy198;
				if (yych == 0x000000A0) goto yy198;
				goto yy61;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy61;
				if (yych <= 0x00002029) goto yy198;
				if (yych <= 0x0000202E) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy192:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy61;
yy196:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych >= 0x00000001) goto yy61;
				} else {
					if (yych <= '\r') goto yy197;
					if (yych <= 0x0000001F) goto yy61;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy61;
				} else {
					if (yych <= '\'') goto yy61;
					if (yych >= '*') goto yy61;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= ',') {
					if (yych <= '+') goto yy200;
					goto yy61;
				} else {
					if (yych <= '-') goto yy200;
					if (yych <= ':') goto yy61;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy199;
					goto yy61;
				} else {
					if (yych == '\\') goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy61;
					goto yy201;
				} else {
					if (yych == 0x00000085) goto yy198;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy61;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy198;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy197:
	yych = *++YYCURSOR;
	goto yy78;
yy198:
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy78;
			if (yych <= '\r') goto yy61;
			goto yy78;
		} else {
			if (yych == '\'') goto yy78;
			if (yych <= '+') goto yy61;
			goto yy78;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy78;
			if (yych <= 'z') goto yy61;
			goto yy78;
		} else {
			if (yych == 0x0000007F) goto yy78;
			if (yych <= 0x0000FFFF) goto yy61;
			goto yy78;
		}
	}
yy199:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy238;
		if (yych <= ',') goto yy61;
		goto yy238;
	} else {
		if (yych <= '.') goto yy239;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy240;
		goto yy61;
	}
yy200:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy202;
		if (yych <= '/') goto yy61;
		goto yy203;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy61;
			goto yy205;
		} else {
			if (yych == 'n') goto yy206;
			goto yy61;
		}
	}
yy201:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych == '!') goto yy61;
				if (yych <= '#') goto yy197;
				goto yy61;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy197;
				if (yych == ';') goto yy197;
				goto yy61;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy197;
					goto yy61;
				} else {
					if (yych <= ']') goto yy197;
					if (yych <= 0x00000084) goto yy61;
					goto yy198;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy198;
				if (yych <= 0x0000167F) goto yy61;
				goto yy198;
			} else {
				if (yych == 0x0000180E) goto yy198;
				if (yych <= 0x00001FFF) goto yy61;
				goto yy198;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy61;
				if (yych <= 0x00002029) goto yy198;
				if (yych <= 0x0000202E) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy202:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych <= '9') goto yy232;
	goto yy61;
yy203:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy66;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ',') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				} else {
					if (yych <= '-') goto yy60;
					if (yych <= '.') goto yy214;
					if (yych <= '/') goto yy216;
					goto yy203;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych == ';') goto yy66;
					if (yych <= 'C') goto yy60;
					goto yy215;
				} else {
					if (yych == 'L') goto yy215;
					if (yych <= 'R') goto yy60;
					goto yy215;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
					goto yy215;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych == 'i') goto yy201;
					if (yych <= 'k') goto yy60;
					goto yy215;
				} else {
					if (yych == 's') goto yy215;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy205:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy197;
					goto yy61;
				} else {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy197;
				if (yych <= 'Z') goto yy61;
				goto yy197;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy61;
					goto yy197;
				} else {
					if (yych == 'n') goto yy211;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy198;
				if (yych == 0x000000A0) goto yy198;
				goto yy61;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy61;
				if (yych <= 0x00002029) goto yy198;
				if (yych <= 0x0000202E) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy206:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy61;
yy210:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy201;
	goto yy61;
yy211:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy210;
	goto yy61;
yy214:
	yych = *++YYCURSOR;
	if (yych <= 'c') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy61;
			if (yych <= '9') goto yy222;
			if (yych <= 'C') goto yy61;
			goto yy224;
		} else {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy61;
				goto yy224;
			} else {
				if (yych == 'S') goto yy224;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'h') {
				if (yych <= 'f') goto yy224;
				goto yy61;
			} else {
				if (yych <= 'i') goto yy201;
				if (yych <= 'k') goto yy61;
				goto yy224;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy61;
				goto yy224;
			} else {
				if (yych == '|') goto yy89;
				goto yy61;
			}
		}
	}
yy215:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy219;
		goto yy61;
	} else {
		if (yych <= '-') goto yy219;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy220;
		goto yy61;
	}
yy216:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy217:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'i') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy217;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy60;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy62;
					if (yych <= 0x0000202E) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy219:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy220:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy220;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych == 'i') goto yy201;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy89;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy222:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ':') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy222;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= 'K') {
					if (yych <= ';') goto yy66;
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy228;
					goto yy60;
				} else {
					if (yych <= 'L') goto yy228;
					if (yych == 'S') goto yy228;
					goto yy60;
				}
			} else {
				if (yych <= '_') {
					if (yych == '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy228;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'k') goto yy60;
					goto yy228;
				} else {
					if (yych == 's') goto yy228;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy224:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy225;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy226;
		goto yy61;
	}
yy225:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy226:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy226;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych == 'i') goto yy201;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy89;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy228:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy229;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy230;
		goto yy61;
	}
yy229:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy230:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy230;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych == 'i') goto yy201;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy89;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy232:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ':') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy232;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= 'K') {
					if (yych <= ';') goto yy66;
					if (yych <= 'C') goto yy60;
					if (yych >= 'G') goto yy60;
				} else {
					if (yych <= 'L') goto yy234;
					if (yych != 'S') goto yy60;
				}
			} else {
				if (yych <= '_') {
					if (yych == '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'c') goto yy60;
					if (yych >= 'g') goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'k') goto yy60;
				} else {
					if (yych == 's') goto yy234;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy234:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy235;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy236;
		goto yy61;
	}
yy235:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy236:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy236;
					goto yy60;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy66;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych == 'i') goto yy201;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy89;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy238:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy239;
		if (yych <= '/') goto yy61;
		goto yy240;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy61;
			goto yy267;
		} else {
			if (yych == 'n') goto yy266;
			goto yy61;
		}
	}
yy239:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych <= '9') goto yy260;
	goto yy61;
yy240:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy60;
					if (yych >= '/') goto yy244;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy240;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= 'F') goto yy243;
					if (yych == 'L') goto yy243;
					goto yy60;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy243;
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy243;
					if (yych <= 'k') goto yy60;
					goto yy243;
				} else {
					if (yych == 's') goto yy243;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy128;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= 'f') {
		if (yych <= ':') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy61;
					goto yy197;
				} else {
					if (yych == ' ') goto yy197;
					goto yy61;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				} else {
					if (yych <= '/') goto yy61;
					if (yych <= '9') goto yy250;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy197;
					if (yych <= 'C') goto yy61;
					goto yy252;
				} else {
					if (yych == 'L') goto yy252;
					goto yy61;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'S') goto yy252;
					if (yych <= 'Z') goto yy61;
					goto yy197;
				} else {
					if (yych == ']') goto yy197;
					if (yych <= 'c') goto yy61;
					goto yy252;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '|') {
				if (yych <= 'r') {
					if (yych == 'l') goto yy252;
					goto yy61;
				} else {
					if (yych <= 's') goto yy252;
					if (yych <= '{') goto yy61;
					goto yy128;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy61;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000205F) goto yy198;
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy243:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy247;
		goto yy61;
	} else {
		if (yych <= '-') goto yy247;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy248;
		goto yy61;
	}
yy244:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy245:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy197;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy197;
					if (yych <= 0x0000001F) goto yy46;
					goto yy197;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= ',') goto yy46;
					if (yych <= '/') goto yy60;
					goto yy245;
				} else {
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy197;
				} else {
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy247:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy248:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy248;
					goto yy60;
				} else {
					if (yych <= ';') goto yy197;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '|') goto yy128;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy250:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= ':') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy250;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy197;
					if (yych <= 'C') goto yy60;
					goto yy256;
				} else {
					if (yych == 'L') goto yy256;
					if (yych <= 'R') goto yy60;
					goto yy256;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy197;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
					goto yy256;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= '|') {
				if (yych <= 'r') {
					if (yych == 'l') goto yy256;
					goto yy60;
				} else {
					if (yych <= 's') goto yy256;
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy60;
					if (yych <= 0x0000007F) goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x00000085) goto yy198;
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy252:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy253;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy254;
		goto yy61;
	}
yy253:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy254:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy254;
					goto yy60;
				} else {
					if (yych <= ';') goto yy197;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '|') goto yy128;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy256:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy257;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy258;
		goto yy61;
	}
yy257:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy258:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy258;
					goto yy60;
				} else {
					if (yych <= ';') goto yy197;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '|') goto yy128;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy260:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= ':') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy260;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy197;
					if (yych <= 'C') goto yy60;
				} else {
					if (yych == 'L') goto yy262;
					if (yych <= 'R') goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy197;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= '|') {
				if (yych <= 'r') {
					if (yych != 'l') goto yy60;
				} else {
					if (yych <= 's') goto yy262;
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy128;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy60;
					if (yych <= 0x0000007F) goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x00000085) goto yy198;
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy262:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy263;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy264;
		goto yy61;
	}
yy263:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy264:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '/') goto yy60;
					if (yych <= '9') goto yy264;
					goto yy60;
				} else {
					if (yych <= ';') goto yy197;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					goto yy60;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '|') goto yy128;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy266:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy271;
	goto yy61;
yy267:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy201;
	goto yy61;
yy271:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy201;
	goto yy61;
yy274:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy196;
	goto yy61;
yy277:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy61;
					goto yy197;
				} else {
					if (yych == ' ') goto yy197;
					if (yych <= '!') goto yy61;
					goto yy197;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy61;
					if (yych <= ')') goto yy197;
					goto yy61;
				} else {
					if (yych == ',') goto yy61;
					if (yych <= '-') goto yy200;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy288;
					if (yych <= ':') goto yy61;
					goto yy197;
				} else {
					if (yych == '@') goto yy199;
					if (yych <= 'C') goto yy61;
					goto yy290;
				}
			} else {
				if (yych <= 'S') {
					if (yych == 'L') goto yy290;
					if (yych <= 'R') goto yy61;
					goto yy290;
				} else {
					if (yych == '[') goto yy197;
					if (yych <= '\\') goto yy61;
					goto yy197;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy290;
					goto yy61;
				} else {
					if (yych <= 'i') goto yy201;
					if (yych == 'l') goto yy290;
					goto yy61;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy290;
					if (yych <= '{') goto yy61;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy198;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000205F) goto yy198;
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy278:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy285;
		goto yy61;
	} else {
		if (yych <= '-') goto yy285;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy286;
		goto yy61;
	}
yy279:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy283;
	goto yy46;
yy280:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy281:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '?') {
				if (yych <= '9') {
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy281;
				} else {
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych <= '@') goto yy199;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x0000007F) {
				if (yych <= 'z') {
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych == '~') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy283:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy283;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy90;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy285:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy286:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy286;
				} else {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '{') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'z') goto yy60;
					goto yy46;
				} else {
					if (yych <= '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy288:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy288;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= '@') {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				} else {
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy294;
					if (yych <= 'K') goto yy60;
					goto yy294;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy294;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= ']') {
						if (yych <= '\\') goto yy65;
						goto yy197;
					} else {
						if (yych == '`') goto yy46;
						goto yy60;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'f') goto yy294;
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych <= 'l') goto yy294;
					if (yych == 's') goto yy294;
					goto yy60;
				}
			} else {
				if (yych <= '~') {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych == 0x00000085) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy290:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy291;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy292;
		goto yy61;
	}
yy291:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy292:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy292;
				} else {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '{') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'z') goto yy60;
					goto yy46;
				} else {
					if (yych <= '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy294:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy295;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy296;
		goto yy61;
	}
yy295:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy296:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy296;
				} else {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '{') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'z') goto yy60;
					goto yy46;
				} else {
					if (yych <= '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy298:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy298;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= '@') {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				} else {
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy300;
					if (yych <= 'K') goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy300;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= ']') {
						if (yych <= '\\') goto yy65;
						goto yy197;
					} else {
						if (yych == '`') goto yy46;
						goto yy60;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'f') goto yy300;
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych <= 'l') goto yy300;
					if (yych != 's') goto yy60;
				}
			} else {
				if (yych <= '~') {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych == 0x00000085) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy300:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy301;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy302;
		goto yy61;
	}
yy301:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy302:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '-') goto yy200;
					if (yych <= '/') goto yy60;
					goto yy302;
				} else {
					if (yych == ';') goto yy197;
					if (yych <= '?') goto yy60;
					goto yy199;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '{') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'z') goto yy60;
					goto yy46;
				} else {
					if (yych <= '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy304:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '}') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy64;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy64;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy186;
					if (yych <= '#') goto yy66;
					goto yy186;
				} else {
					if (yych <= '\'') goto yy64;
					if (yych <= ')') goto yy66;
					goto yy186;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= ',') goto yy64;
					goto yy186;
				} else {
					if (yych <= ';') goto yy66;
					if (yych <= 'Z') goto yy186;
					goto yy66;
				}
			} else {
				if (yych <= '_') {
					if (yych <= '\\') goto yy306;
					if (yych <= ']') goto yy66;
					goto yy186;
				} else {
					if (yych <= '`') goto yy64;
					if (yych <= 'z') goto yy186;
					goto yy64;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x0000009F) {
				if (yych <= 0x0000007F) {
					if (yych <= '~') goto yy186;
					goto yy64;
				} else {
					if (yych == 0x00000085) goto yy304;
					goto yy186;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x000000A0) goto yy304;
					if (yych <= 0x0000167F) goto yy186;
					goto yy304;
				} else {
					if (yych == 0x0000180E) goto yy304;
					goto yy186;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00002029) goto yy304;
					if (yych <= 0x0000202E) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00003000) goto yy304;
					if (yych <= 0x0000FFFF) goto yy186;
					goto yy64;
				}
			}
		}
	}
yy306:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych != 'x') goto yy46;
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy308;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy308:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy308;
		if (yych <= ':') goto yy46;
		goto yy186;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy308;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy308;
			goto yy46;
		}
	}
yy310:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy77;
				if (yych <= 'Z') goto yy46;
				goto yy77;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'n') goto yy343;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy311:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy339;
	goto yy46;
yy312:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy321;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy323;
					if (yych <= '9') goto yy312;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy322;
					if (yych == 'L') goto yy322;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy322;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
					goto yy322;
				} else {
					if (yych == 'i') goto yy90;
					if (yych <= 'k') goto yy46;
					goto yy322;
				}
			} else {
				if (yych <= '|') {
					if (yych == 's') goto yy322;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy314:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy315:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy315;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					if (yych <= 'C') goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych == 'L') goto yy317;
					if (yych <= 'R') goto yy46;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= 'c') goto yy46;
					if (yych >= 'g') goto yy46;
				} else {
					if (yych <= 'i') goto yy90;
					if (yych != 'l') goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy317;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy317:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy318;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy319;
		goto yy46;
	}
yy318:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy319:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '-') goto yy80;
					goto yy46;
				} else {
					if (yych <= '9') goto yy319;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy79;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy321:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy330;
			if (yych <= 'F') goto yy331;
			goto yy330;
		} else {
			if (yych <= 'L') goto yy331;
			if (yych <= 'R') goto yy330;
			goto yy331;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy330;
			if (yych <= 'f') goto yy331;
			goto yy330;
		} else {
			if (yych <= 'l') goto yy331;
			if (yych == 's') goto yy331;
			goto yy330;
		}
	}
yy322:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy326;
		goto yy46;
	} else {
		if (yych <= '-') goto yy326;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy327;
		goto yy46;
	}
yy323:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy324:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy324;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy90;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy326:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy327:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '-') goto yy80;
					goto yy46;
				} else {
					if (yych <= '9') goto yy327;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy79;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy329:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy330:
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy329;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					if (yych <= 'C') goto yy46;
					goto yy335;
				}
			} else {
				if (yych <= 'S') {
					if (yych == 'L') goto yy335;
					if (yych <= 'R') goto yy46;
					goto yy335;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy335;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy90;
					if (yych == 'l') goto yy335;
					goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy335;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy331:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy332;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy333;
		goto yy46;
	}
yy332:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy333:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '-') goto yy80;
					goto yy46;
				} else {
					if (yych <= '9') goto yy333;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy79;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy335:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy336;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy337;
		goto yy46;
	}
yy336:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy337:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '-') goto yy80;
					goto yy46;
				} else {
					if (yych <= '9') goto yy337;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy79;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy339:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy342:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy79;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy343:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy342;
	goto yy46;
yy346:
	++YYCURSOR;
#line 501 "src/scanner.re"
	{
            comment_count = 1;
            goto comment;
        }
#line 8200 "<stdout>"
yy348:
	++YYCURSOR;
#line 497 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return DATUM_COMMENT;
        }
#line 8208 "<stdout>"
yy350:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy811;
	goto yy46;
yy351:
	yych = *++YYCURSOR;
	if (yych == '8') goto yy808;
	goto yy46;
yy352:
	++YYCURSOR;
#line 477 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return VECTOR_START;
        }
#line 8224 "<stdout>"
yy354:
	yych = *++YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= ',') goto yy794;
		if (yych <= '9') goto yy796;
		if (yych <= '@') goto yy794;
		goto yy796;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy794;
			goto yy796;
		} else {
			if (yych <= '`') goto yy794;
			if (yych <= 'z') goto yy796;
			goto yy794;
		}
	}
yy355:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy790;
	goto yy788;
yy356:
	yych = *++YYCURSOR;
	goto yy786;
yy357:
	yych = *++YYCURSOR;
	goto yy784;
yy358:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy779;
	if (yych == '\\') goto yy777;
	goto yy358;
yy360:
	yych = *++YYCURSOR;
	if (yych <= '.') {
		if (yych <= '*') {
			if (yych == '#') goto yy776;
			goto yy46;
		} else {
			if (yych == ',') goto yy46;
			if (yych <= '-') goto yy609;
			goto yy614;
		}
	} else {
		if (yych <= '@') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy610;
			goto yy46;
		} else {
			if (yych <= 'F') goto yy612;
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy612;
			goto yy46;
		}
	}
yy361:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy607;
	case '+':
	case '-':	goto yy549;
	case '.':	goto yy550;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy167;
	default:	goto yy46;
	}
yy362:
	yych = *++YYCURSOR;
	if (yych <= '+') {
		if (yych == '#') goto yy552;
		if (yych <= '*') goto yy46;
		goto yy553;
	} else {
		if (yych <= '-') {
			if (yych <= ',') goto yy46;
			goto yy553;
		} else {
			if (yych <= '/') goto yy46;
			if (yych <= '7') goto yy554;
			goto yy46;
		}
	}
yy363:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy548;
	case '+':
	case '-':	goto yy549;
	case '.':	goto yy550;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy167;
	default:	goto yy46;
	}
yy364:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy493;
	case '+':
	case '-':	goto yy494;
	case '0':
	case '1':	goto yy495;
	default:	goto yy46;
	}
yy365:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'a':	goto yy393;
	case 'b':	goto yy394;
	case 'd':	goto yy400;
	case 'e':	goto yy401;
	case 'l':	goto yy396;
	case 'n':	goto yy392;
	case 'p':	goto yy398;
	case 'r':	goto yy399;
	case 's':	goto yy391;
	case 't':	goto yy395;
	case 'v':	goto yy397;
	case 'x':	goto yy403;
	default:	goto yy402;
	}
yy366:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy383;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy383;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy383;
					goto yy46;
				} else {
					if (yych <= '#') goto yy383;
					if (yych <= '\'') goto yy46;
					goto yy383;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy383;
				if (yych <= 'Z') goto yy46;
				goto yy383;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy383;
				} else {
					if (yych == 'a') goto yy385;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy383;
				if (yych == 0x000000A0) goto yy383;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy383;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy383;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy383;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy383;
				if (yych <= 0x0000202E) goto yy46;
				goto yy383;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy383;
				} else {
					if (yych == 0x00003000) goto yy383;
					goto yy46;
				}
			}
		}
	}
yy367:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy383;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy383;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy383;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy383;
				if (yych == ';') goto yy383;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy383;
					goto yy46;
				} else {
					if (yych <= ']') goto yy383;
					if (yych <= 0x00000084) goto yy46;
					goto yy383;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy383;
				if (yych <= 0x0000167F) goto yy46;
				goto yy383;
			} else {
				if (yych == 0x0000180E) goto yy383;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy383;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy383;
				if (yych <= 0x0000202E) goto yy46;
				goto yy383;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy383;
				} else {
					if (yych == 0x00003000) goto yy383;
					goto yy46;
				}
			}
		}
	}
yy368:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '/') {
		if (yych == '#') goto yy381;
		goto yy46;
	} else {
		if (yych <= '9') goto yy368;
		if (yych == '=') goto yy379;
		goto yy46;
	}
yy370:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy372;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy372;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy372;
					goto yy46;
				} else {
					if (yych <= '#') goto yy372;
					if (yych <= '\'') goto yy46;
					goto yy372;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy372;
				if (yych <= 'Z') goto yy46;
				goto yy372;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy372;
				} else {
					if (yych == 'r') goto yy374;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy372;
				if (yych == 0x000000A0) goto yy372;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy372;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy372;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy372;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy372;
				if (yych <= 0x0000202E) goto yy46;
				goto yy372;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy372;
				} else {
					if (yych == 0x00003000) goto yy372;
					goto yy46;
				}
			}
		}
	}
yy371:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy372;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy372;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy372;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy372;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy372;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy372;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy372:
	++YYCURSOR;
#line 246 "src/scanner.re"
	{
            yylval->boolValue = true;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8624 "<stdout>"
yy374:
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy377;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy377;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy377;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy377;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy377;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy377;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy377:
	++YYCURSOR;
#line 252 "src/scanner.re"
	{
            yylval->boolValue = true;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8686 "<stdout>"
yy379:
	++YYCURSOR;
#line 258 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINING_SHARED;
        }
#line 8696 "<stdout>"
yy381:
	++YYCURSOR;
#line 264 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINED_SHARED;
        }
#line 8706 "<stdout>"
yy383:
	++YYCURSOR;
#line 270 "src/scanner.re"
	{
            yylval->boolValue = false;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8716 "<stdout>"
yy385:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 's') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy389;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy389;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy389;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy389;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy389;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy389;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy389:
	++YYCURSOR;
#line 276 "src/scanner.re"
	{
            yylval->boolValue = false;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8780 "<stdout>"
yy391:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'p') goto yy487;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy392:
	yych = *++YYCURSOR;
	if (yych <= 'u') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '\\') {
				if (yych <= ';') {
					if (yych <= ':') goto yy46;
					goto yy406;
				} else {
					if (yych == '[') goto yy406;
					goto yy46;
				}
			} else {
				if (yych <= 'd') {
					if (yych <= ']') goto yy406;
					goto yy46;
				} else {
					if (yych <= 'e') goto yy473;
					if (yych <= 't') goto yy46;
					goto yy472;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy406;
				if (yych <= 0x0000009F) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x0000180E) goto yy406;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy406;
					if (yych <= 0x0000202E) goto yy46;
					goto yy406;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy393:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'l') goto yy466;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy394:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'a') goto yy456;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy395:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'a') goto yy452;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy396:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'i') goto yy443;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy397:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 't') goto yy438;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy398:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'a') goto yy433;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy399:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'e') goto yy426;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy400:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 'e') goto yy419;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy401:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy406;
					goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy406;
				if (yych <= 'Z') goto yy46;
				goto yy406;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy406;
				} else {
					if (yych == 's') goto yy410;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych == 0x000000A0) goto yy406;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy406;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy406;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy402:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy406;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy406;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy406;
				if (yych == ';') goto yy406;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy406;
					goto yy46;
				} else {
					if (yych <= ']') goto yy406;
					if (yych <= 0x00000084) goto yy46;
					goto yy406;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy406;
				if (yych <= 0x0000167F) goto yy46;
				goto yy406;
			} else {
				if (yych == 0x0000180E) goto yy406;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy406;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy46;
				}
			}
		}
	}
yy403:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy405;
				if (yych <= '\r') goto yy406;
				goto yy405;
			} else {
				if (yych == '!') goto yy405;
				if (yych <= '#') goto yy406;
				goto yy405;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy406;
				if (yych == ';') goto yy406;
				goto yy405;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy406;
					goto yy405;
				} else {
					if (yych <= ']') goto yy406;
					if (yych <= 0x00000084) goto yy405;
					goto yy406;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy406;
				if (yych <= 0x0000167F) goto yy405;
				goto yy406;
			} else {
				if (yych == 0x0000180E) goto yy406;
				if (yych <= 0x00001FFF) goto yy405;
				goto yy406;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy405;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy405;
				goto yy406;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy405;
					goto yy406;
				} else {
					if (yych == 0x00003000) goto yy406;
					goto yy405;
				}
			}
		}
	}
yy404:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy405:
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy408;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy408;
					if (yych <= 0x0000001F) goto yy46;
					goto yy408;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy408;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy408;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ':') {
					if (yych <= '9') goto yy404;
					goto yy46;
				} else {
					if (yych <= ';') goto yy408;
					if (yych <= '@') goto yy46;
					goto yy404;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy408;
				} else {
					if (yych == ']') goto yy408;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= 'f') goto yy404;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy408;
					if (yych <= 0x0000009F) goto yy46;
					goto yy408;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy408;
				} else {
					if (yych == 0x0000180E) goto yy408;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy408;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy408;
					if (yych <= 0x0000202E) goto yy46;
					goto yy408;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy408;
				} else {
					if (yych == 0x00003000) goto yy408;
					goto yy46;
				}
			}
		}
	}
yy406:
	++YYCURSOR;
#line 366 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[2];
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9738 "<stdout>"
yy408:
	++YYCURSOR;
#line 372 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->charValue = ScannerHelper::hexStringToUCS4Char(YYTOKEN + 3, YYCURSOR );
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9748 "<stdout>"
yy410:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy412;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy412;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy412;
				if (yych <= 'Z') goto yy46;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
				} else {
					if (yych == 'a') goto yy414;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy412;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy412;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy412;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy412:
	++YYCURSOR;
#line 360 "src/scanner.re"
	{
            yylval->charValue = 0x1B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9816 "<stdout>"
yy414:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy417;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy417;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy417;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy417;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy417;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy417;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy417:
	++YYCURSOR;
#line 354 "src/scanner.re"
	{
            yylval->charValue = 0x1B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9878 "<stdout>"
yy419:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy424;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy424;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy424;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy424;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy424;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy424;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy424:
	++YYCURSOR;
#line 348 "src/scanner.re"
	{
            yylval->charValue = 0x7F;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9944 "<stdout>"
yy426:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy431;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy431;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy431;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy431;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy431;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy431;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy431:
	++YYCURSOR;
#line 342 "src/scanner.re"
	{
            yylval->charValue = 0x0D;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10010 "<stdout>"
yy433:
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy436;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy436;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy436;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy436;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy436;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy436;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy436:
	++YYCURSOR;
#line 336 "src/scanner.re"
	{
            yylval->charValue = 0x0C;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10072 "<stdout>"
yy438:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy441;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy441;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy441;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy441;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy441;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy441;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy441:
	++YYCURSOR;
#line 330 "src/scanner.re"
	{
            yylval->charValue = 0x0B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10134 "<stdout>"
yy443:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'd') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy450;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy450;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy450;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy450;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy450;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy450;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy450:
	++YYCURSOR;
#line 324 "src/scanner.re"
	{
            yylval->charValue = 0x0A;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10204 "<stdout>"
yy452:
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy454;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy454;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy454;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy454;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy454;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy454;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy454:
	++YYCURSOR;
#line 318 "src/scanner.re"
	{
            yylval->charValue = 0x09;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10264 "<stdout>"
yy456:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'k') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 's') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy464;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy464;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy464;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy464;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy464;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy464;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy464:
	++YYCURSOR;
#line 312 "src/scanner.re"
	{
            yylval->charValue = 0x08;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10336 "<stdout>"
yy466:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy470;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy470;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy470;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy470;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy470;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy470;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy470:
	++YYCURSOR;
#line 306 "src/scanner.re"
	{
            yylval->charValue = 0x07;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10400 "<stdout>"
yy472:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy481;
	goto yy46;
yy473:
	yych = *++YYCURSOR;
	if (yych != 'w') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy479;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy479;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy479;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy479;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy479;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy479;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy479:
	++YYCURSOR;
#line 288 "src/scanner.re"
	{
            yylval->charValue = '\n';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10472 "<stdout>"
yy481:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy483;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy483;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy483;
					goto yy46;
				} else {
					if (yych <= '#') goto yy483;
					if (yych <= '\'') goto yy46;
					goto yy483;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy483;
				if (yych <= 'Z') goto yy46;
				goto yy483;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy483;
				} else {
					if (yych != 'l') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy483;
				if (yych == 0x000000A0) goto yy483;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy483;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy483;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy483;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy483;
				if (yych <= 0x0000202E) goto yy46;
				goto yy483;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy483;
				} else {
					if (yych == 0x00003000) goto yy483;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy485;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy485;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy485;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy485;
				if (yych == ';') goto yy485;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy485;
					goto yy46;
				} else {
					if (yych <= ']') goto yy485;
					if (yych <= 0x00000084) goto yy46;
					goto yy485;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy485;
				if (yych <= 0x0000167F) goto yy46;
				goto yy485;
			} else {
				if (yych == 0x0000180E) goto yy485;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy485;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy485;
				if (yych <= 0x0000202E) goto yy46;
				goto yy485;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy485;
				} else {
					if (yych == 0x00003000) goto yy485;
					goto yy46;
				}
			}
		}
	}
yy483:
	++YYCURSOR;
#line 294 "src/scanner.re"
	{
            yylval->charValue = 0x00;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10605 "<stdout>"
yy485:
	++YYCURSOR;
#line 300 "src/scanner.re"
	{
            yylval->charValue = 0x00;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10615 "<stdout>"
yy487:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy491;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy491;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy491;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy491;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy491;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy491;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy491:
	++YYCURSOR;
#line 282 "src/scanner.re"
	{
            yylval->charValue = ' ';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10679 "<stdout>"
yy493:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy547;
		if (yych <= 'H') goto yy46;
		goto yy547;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy547;
		} else {
			if (yych == 'i') goto yy547;
			goto yy46;
		}
	}
yy494:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy535;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy533;
		if (yych == 'n') goto yy534;
		goto yy46;
	}
yy495:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy500;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy500;
					if (yych <= 0x0000001F) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy500;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy500;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy498;
					goto yy46;
				} else {
					if (yych <= '-') goto yy498;
					if (yych <= '.') goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '1') goto yy495;
					if (yych <= ':') goto yy46;
					goto yy500;
				} else {
					if (yych == '@') goto yy499;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy500;
					goto yy46;
				} else {
					if (yych <= ']') goto yy500;
					if (yych <= 0x00000084) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy500;
					if (yych <= 0x0000180D) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy500;
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy531;
	goto yy46;
yy498:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy517;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy520;
		if (yych == 'n') goto yy519;
		goto yy46;
	}
yy499:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy502;
		goto yy46;
	} else {
		if (yych <= '-') goto yy502;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy503;
		goto yy46;
	}
yy500:
	++YYCURSOR;
#line 380 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 10829 "<stdout>"
yy502:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '2') goto yy46;
	} else {
		if (yych <= 'i') goto yy509;
		if (yych == 'n') goto yy508;
		goto yy46;
	}
yy503:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy500;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy500;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy500;
					goto yy46;
				} else {
					if (yych <= '#') goto yy500;
					if (yych <= '\'') goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') goto yy46;
				if (yych <= '/') goto yy505;
				if (yych <= '1') goto yy503;
				goto yy46;
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy500;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy500;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy500;
				if (yych <= 0x0000009F) goto yy46;
				goto yy500;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x0000180E) goto yy500;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy500;
					if (yych <= 0x0000202E) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy505:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy506:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy500;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy500;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy500;
					goto yy46;
				} else {
					if (yych <= '#') goto yy500;
					if (yych <= '\'') goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '1') goto yy506;
				if (yych <= ':') goto yy46;
				goto yy500;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy500;
				} else {
					if (yych == ']') goto yy500;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy500;
				if (yych == 0x000000A0) goto yy500;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy500;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy500;
				if (yych <= 0x0000202E) goto yy46;
				goto yy500;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy508:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy514;
	goto yy46;
yy509:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy513:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy500;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy500;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy500;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy500;
				if (yych == ';') goto yy500;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy500;
					goto yy46;
				} else {
					if (yych <= ']') goto yy500;
					if (yych <= 0x00000084) goto yy46;
					goto yy500;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy500;
				if (yych <= 0x0000167F) goto yy46;
				goto yy500;
			} else {
				if (yych == 0x0000180E) goto yy500;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy500;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy500;
				if (yych <= 0x0000202E) goto yy46;
				goto yy500;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy514:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy513;
	goto yy46;
yy517:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '1') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy528;
		goto yy517;
	} else {
		if (yych == 'i') goto yy513;
		goto yy46;
	}
yy519:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy525;
	goto yy46;
yy520:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy500;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy500;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy500;
					goto yy46;
				} else {
					if (yych <= '#') goto yy500;
					if (yych <= '\'') goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy500;
				if (yych <= 'Z') goto yy46;
				goto yy500;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy500;
				} else {
					if (yych != 'n') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy500;
				if (yych == 0x000000A0) goto yy500;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy500;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy500;
				if (yych <= 0x0000202E) goto yy46;
				goto yy500;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy524:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy513;
	goto yy46;
yy525:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy524;
	goto yy46;
yy528:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy529:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy529;
	if (yych == 'i') goto yy513;
	goto yy46;
yy531:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy500;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy500;
					if (yych <= 0x0000001F) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy500;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy500;
					goto yy46;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= ',') {
					if (yych <= '+') goto yy498;
					goto yy46;
				} else {
					if (yych <= '-') goto yy498;
					if (yych <= '/') goto yy46;
					goto yy531;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy500;
					goto yy46;
				} else {
					if (yych <= '@') goto yy499;
					if (yych <= 'Z') goto yy46;
					goto yy500;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00000085) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy500;
					if (yych <= 0x0000180D) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy500;
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy533:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy500;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy500;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy500;
					goto yy46;
				} else {
					if (yych <= '#') goto yy500;
					if (yych <= '\'') goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy500;
				if (yych <= 'Z') goto yy46;
				goto yy500;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy500;
				} else {
					if (yych == 'n') goto yy544;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy500;
				if (yych == 0x000000A0) goto yy500;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy500;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy500;
				if (yych <= 0x0000202E) goto yy46;
				goto yy500;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy534:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy540;
	goto yy46;
yy535:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy500;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy500;
					if (yych <= 0x0000001F) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy500;
					goto yy46;
				} else {
					if (yych <= ')') goto yy500;
					if (yych <= '*') goto yy46;
					goto yy498;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy498;
				} else {
					if (yych <= '.') goto yy46;
					if (yych >= '0') goto yy535;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy500;
					goto yy46;
				} else {
					if (yych <= '@') goto yy499;
					if (yych <= 'Z') goto yy46;
					goto yy500;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy500;
				} else {
					if (yych == 'i') goto yy513;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy500;
					if (yych <= 0x0000009F) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00001680) goto yy500;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy500;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy500;
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy538:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy500;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy500;
					if (yych <= 0x0000001F) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy500;
					goto yy46;
				} else {
					if (yych <= ')') goto yy500;
					if (yych <= '*') goto yy46;
					goto yy498;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy498;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '1') goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy500;
					if (yych <= '?') goto yy46;
					goto yy499;
				} else {
					if (yych == '[') goto yy500;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy500;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy513;
					if (yych <= 0x00000084) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy500;
					if (yych <= 0x0000180D) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy500;
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy540:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy543:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy500;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy500;
					if (yych <= 0x0000001F) goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy500;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy500;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= ',') {
					if (yych <= '+') goto yy498;
					goto yy46;
				} else {
					if (yych <= '-') goto yy498;
					if (yych <= ':') goto yy46;
					goto yy500;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy499;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy500;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy513;
				} else {
					if (yych == 0x00000085) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy500;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy500;
					if (yych <= 0x0000180D) goto yy46;
					goto yy500;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy500;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy500;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy500;
					if (yych <= 0x0000205E) goto yy46;
					goto yy500;
				} else {
					if (yych == 0x00003000) goto yy500;
					goto yy46;
				}
			}
		}
	}
yy544:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy543;
	goto yy46;
yy547:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy494;
		goto yy46;
	} else {
		if (yych <= '-') goto yy494;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy495;
		goto yy46;
	}
yy548:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy551;
		if (yych <= 'H') goto yy46;
		goto yy551;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy551;
		} else {
			if (yych == 'i') goto yy551;
			goto yy46;
		}
	}
yy549:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy314;
		if (yych <= '/') goto yy46;
		goto yy312;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy310;
		} else {
			if (yych == 'n') goto yy311;
			goto yy46;
		}
	}
yy550:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy73;
	goto yy46;
yy551:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy549;
		if (yych <= ',') goto yy46;
		goto yy549;
	} else {
		if (yych <= '.') goto yy550;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy167;
		goto yy46;
	}
yy552:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy606;
		if (yych <= 'H') goto yy46;
		goto yy606;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy606;
		} else {
			if (yych == 'i') goto yy606;
			goto yy46;
		}
	}
yy553:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy594;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy592;
		if (yych == 'n') goto yy593;
		goto yy46;
	}
yy554:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy559;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy559;
					if (yych <= 0x0000001F) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy559;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy559;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy557;
					goto yy46;
				} else {
					if (yych <= '-') goto yy557;
					if (yych <= '.') goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '7') goto yy554;
					if (yych <= ':') goto yy46;
					goto yy559;
				} else {
					if (yych == '@') goto yy558;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy559;
					goto yy46;
				} else {
					if (yych <= ']') goto yy559;
					if (yych <= 0x00000084) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy559;
					if (yych <= 0x0000180D) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy559;
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy590;
	goto yy46;
yy557:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy576;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy579;
		if (yych == 'n') goto yy578;
		goto yy46;
	}
yy558:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy561;
		goto yy46;
	} else {
		if (yych <= '-') goto yy561;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy562;
		goto yy46;
	}
yy559:
	++YYCURSOR;
#line 392 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 11826 "<stdout>"
yy561:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '8') goto yy46;
	} else {
		if (yych <= 'i') goto yy568;
		if (yych == 'n') goto yy567;
		goto yy46;
	}
yy562:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy559;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy559;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy559;
					goto yy46;
				} else {
					if (yych <= '#') goto yy559;
					if (yych <= '\'') goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') goto yy46;
				if (yych <= '/') goto yy564;
				if (yych <= '7') goto yy562;
				goto yy46;
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy559;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy559;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy559;
				if (yych <= 0x0000009F) goto yy46;
				goto yy559;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x0000180E) goto yy559;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy559;
					if (yych <= 0x0000202E) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy564:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy565:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy559;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy559;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy559;
					goto yy46;
				} else {
					if (yych <= '#') goto yy559;
					if (yych <= '\'') goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '7') goto yy565;
				if (yych <= ':') goto yy46;
				goto yy559;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy559;
				} else {
					if (yych == ']') goto yy559;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy559;
				if (yych == 0x000000A0) goto yy559;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy559;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy559;
				if (yych <= 0x0000202E) goto yy46;
				goto yy559;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy567:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy573;
	goto yy46;
yy568:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy572:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy559;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy559;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy559;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy559;
				if (yych == ';') goto yy559;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy559;
					goto yy46;
				} else {
					if (yych <= ']') goto yy559;
					if (yych <= 0x00000084) goto yy46;
					goto yy559;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy559;
				if (yych <= 0x0000167F) goto yy46;
				goto yy559;
			} else {
				if (yych == 0x0000180E) goto yy559;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy559;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy559;
				if (yych <= 0x0000202E) goto yy46;
				goto yy559;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy573:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy572;
	goto yy46;
yy576:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '7') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy587;
		goto yy576;
	} else {
		if (yych == 'i') goto yy572;
		goto yy46;
	}
yy578:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy584;
	goto yy46;
yy579:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy559;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy559;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy559;
					goto yy46;
				} else {
					if (yych <= '#') goto yy559;
					if (yych <= '\'') goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy559;
				if (yych <= 'Z') goto yy46;
				goto yy559;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy559;
				} else {
					if (yych != 'n') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy559;
				if (yych == 0x000000A0) goto yy559;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy559;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy559;
				if (yych <= 0x0000202E) goto yy46;
				goto yy559;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy583:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy572;
	goto yy46;
yy584:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy583;
	goto yy46;
yy587:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy588:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy588;
	if (yych == 'i') goto yy572;
	goto yy46;
yy590:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy559;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy559;
					if (yych <= 0x0000001F) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy559;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy559;
					goto yy46;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= ',') {
					if (yych <= '+') goto yy557;
					goto yy46;
				} else {
					if (yych <= '-') goto yy557;
					if (yych <= '/') goto yy46;
					goto yy590;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy559;
					goto yy46;
				} else {
					if (yych <= '@') goto yy558;
					if (yych <= 'Z') goto yy46;
					goto yy559;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00000085) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy559;
					if (yych <= 0x0000180D) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy559;
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy592:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy559;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy559;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy559;
					goto yy46;
				} else {
					if (yych <= '#') goto yy559;
					if (yych <= '\'') goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy559;
				if (yych <= 'Z') goto yy46;
				goto yy559;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy559;
				} else {
					if (yych == 'n') goto yy603;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy559;
				if (yych == 0x000000A0) goto yy559;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy559;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy559;
				if (yych <= 0x0000202E) goto yy46;
				goto yy559;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy593:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy599;
	goto yy46;
yy594:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy559;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy559;
					if (yych <= 0x0000001F) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy559;
					goto yy46;
				} else {
					if (yych <= ')') goto yy559;
					if (yych <= '*') goto yy46;
					goto yy557;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy557;
				} else {
					if (yych <= '.') goto yy46;
					if (yych >= '0') goto yy594;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy559;
					goto yy46;
				} else {
					if (yych <= '@') goto yy558;
					if (yych <= 'Z') goto yy46;
					goto yy559;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy559;
				} else {
					if (yych == 'i') goto yy572;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy559;
					if (yych <= 0x0000009F) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00001680) goto yy559;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy559;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy559;
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy597:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy559;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy559;
					if (yych <= 0x0000001F) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy559;
					goto yy46;
				} else {
					if (yych <= ')') goto yy559;
					if (yych <= '*') goto yy46;
					goto yy557;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy557;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '7') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy559;
					if (yych <= '?') goto yy46;
					goto yy558;
				} else {
					if (yych == '[') goto yy559;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy559;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy572;
					if (yych <= 0x00000084) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy559;
					if (yych <= 0x0000180D) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy559;
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy599:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy602:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy559;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy559;
					if (yych <= 0x0000001F) goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy559;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy559;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= ',') {
					if (yych <= '+') goto yy557;
					goto yy46;
				} else {
					if (yych <= '-') goto yy557;
					if (yych <= ':') goto yy46;
					goto yy559;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy558;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy559;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy572;
				} else {
					if (yych == 0x00000085) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy559;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy559;
					if (yych <= 0x0000180D) goto yy46;
					goto yy559;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy559;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy559;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy559;
					if (yych <= 0x0000205E) goto yy46;
					goto yy559;
				} else {
					if (yych == 0x00003000) goto yy559;
					goto yy46;
				}
			}
		}
	}
yy603:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy602;
	goto yy46;
yy606:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy553;
		goto yy46;
	} else {
		if (yych <= '-') goto yy553;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy554;
		goto yy46;
	}
yy607:
	yych = *++YYCURSOR;
	if (yych <= 'X') {
		if (yych <= 'D') {
			if (yych == 'B') goto yy547;
			if (yych <= 'C') goto yy46;
			goto yy551;
		} else {
			if (yych == 'O') goto yy606;
			if (yych <= 'W') goto yy46;
		}
	} else {
		if (yych <= 'd') {
			if (yych == 'b') goto yy547;
			if (yych <= 'c') goto yy46;
			goto yy551;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy46;
				goto yy606;
			} else {
				if (yych != 'x') goto yy46;
			}
		}
	}
yy608:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych != '+') goto yy46;
		} else {
			if (yych <= '-') goto yy609;
			if (yych <= '.') goto yy614;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy610;
			if (yych <= '@') goto yy46;
			goto yy612;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy612;
			goto yy46;
		}
	}
yy609:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy738;
			goto yy46;
		} else {
			if (yych <= '9') goto yy734;
			if (yych <= '@') goto yy46;
			goto yy736;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy736;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy732;
			if (yych == 'n') goto yy733;
			goto yy46;
		}
	}
yy610:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy711;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy708;
					if (yych <= '9') goto yy610;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy712;
					if (yych <= 'K') goto yy46;
					goto yy713;
				} else {
					if (yych == 'S') goto yy713;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= '`') {
					if (yych == ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'c') goto yy612;
					if (yych <= 'f') goto yy712;
					if (yych <= 'k') goto yy46;
					goto yy713;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy713;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy612:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych == '-') goto yy621;
					goto yy46;
				} else {
					if (yych <= '/') goto yy708;
					if (yych <= '9') goto yy612;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych <= 'F') goto yy612;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy612;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy614:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy615:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych == '+') goto yy621;
					if (yych <= ',') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy615;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych == '@') goto yy620;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy617;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy617;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'c') {
					if (yych == ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy617;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy617:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy705;
		goto yy46;
	} else {
		if (yych <= '-') goto yy705;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy706;
		goto yy46;
	}
yy618:
	++YYCURSOR;
#line 398 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 12998 "<stdout>"
yy620:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych == '+') goto yy664;
			goto yy46;
		} else {
			if (yych <= '-') goto yy664;
			if (yych <= '.') goto yy669;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy665;
			if (yych <= '@') goto yy46;
			goto yy667;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy667;
			goto yy46;
		}
	}
yy621:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy628;
			goto yy46;
		} else {
			if (yych <= '9') goto yy624;
			if (yych <= '@') goto yy46;
			goto yy626;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy626;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy622;
			if (yych == 'n') goto yy623;
			goto yy46;
		}
	}
yy622:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy618;
				if (yych <= 'Z') goto yy46;
				goto yy618;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 'n') goto yy661;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy623:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy657;
	goto yy46;
yy624:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'R') {
		if (yych <= '@') {
			if (yych <= '.') {
				if (yych <= '-') goto yy46;
				goto yy639;
			} else {
				if (yych <= '/') goto yy636;
				if (yych <= '9') goto yy624;
				goto yy46;
			}
		} else {
			if (yych <= 'F') {
				if (yych >= 'D') goto yy640;
			} else {
				if (yych == 'L') goto yy641;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') {
				if (yych <= 'S') goto yy641;
				goto yy46;
			} else {
				if (yych <= 'c') goto yy626;
				if (yych <= 'f') goto yy640;
				goto yy46;
			}
		} else {
			if (yych <= 'l') {
				if (yych <= 'i') goto yy632;
				if (yych <= 'k') goto yy46;
				goto yy641;
			} else {
				if (yych == 's') goto yy641;
				goto yy46;
			}
		}
	}
yy626:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy636;
		} else {
			if (yych <= '9') goto yy626;
			if (yych <= '@') goto yy46;
			goto yy626;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy626;
		} else {
			if (yych == 'i') goto yy632;
			goto yy46;
		}
	}
yy628:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy629:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy629;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych == 'L') goto yy631;
			if (yych <= 'R') goto yy46;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy631;
			if (yych <= 'h') goto yy46;
			goto yy632;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
			} else {
				if (yych != 's') goto yy46;
			}
		}
	}
yy631:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy633;
		goto yy46;
	} else {
		if (yych <= '-') goto yy633;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy634;
		goto yy46;
	}
yy632:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych <= '#') goto yy618;
				goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy618;
				if (yych == ';') goto yy618;
				goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy618;
					goto yy46;
				} else {
					if (yych <= ']') goto yy618;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy618;
				if (yych <= 0x0000167F) goto yy46;
				goto yy618;
			} else {
				if (yych == 0x0000180E) goto yy618;
				if (yych <= 0x00001FFF) goto yy46;
				goto yy618;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy633:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy634:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy634;
	if (yych == 'i') goto yy632;
	goto yy46;
yy636:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy46;
	goto yy638;
yy637:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy638:
	if (yych <= 'F') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy637;
		if (yych <= '@') goto yy46;
		goto yy637;
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy637;
		} else {
			if (yych == 'i') goto yy632;
			goto yy46;
		}
	}
yy639:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy648;
			if (yych <= 'F') goto yy649;
			goto yy648;
		} else {
			if (yych <= 'L') goto yy649;
			if (yych <= 'R') goto yy648;
			goto yy649;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy648;
			if (yych <= 'f') goto yy649;
			goto yy648;
		} else {
			if (yych <= 'l') goto yy649;
			if (yych == 's') goto yy649;
			goto yy648;
		}
	}
yy640:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy642;
	if (yych == '-') goto yy642;
	goto yy646;
yy641:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy642;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy643;
		goto yy46;
	}
yy642:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy643:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy643;
	if (yych == 'i') goto yy632;
	goto yy46;
yy645:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy646:
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy636;
		} else {
			if (yych <= '9') goto yy645;
			if (yych <= '@') goto yy46;
			goto yy626;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy626;
		} else {
			if (yych == 'i') goto yy632;
			goto yy46;
		}
	}
yy647:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy648:
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy647;
			if (yych <= 'C') goto yy46;
			goto yy653;
		} else {
			if (yych == 'L') goto yy653;
			if (yych <= 'R') goto yy46;
			goto yy653;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy653;
			if (yych <= 'h') goto yy46;
			goto yy632;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
				goto yy653;
			} else {
				if (yych == 's') goto yy653;
				goto yy46;
			}
		}
	}
yy649:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy650;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy651;
		goto yy46;
	}
yy650:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy651:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy651;
	if (yych == 'i') goto yy632;
	goto yy46;
yy653:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy654;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy655;
		goto yy46;
	}
yy654:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy655:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy655;
	if (yych == 'i') goto yy632;
	goto yy46;
yy657:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy660:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy632;
	goto yy46;
yy661:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy660;
	goto yy46;
yy664:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy669;
			goto yy46;
		} else {
			if (yych <= '9') goto yy665;
			if (yych <= '@') goto yy46;
			goto yy667;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy667;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy698;
			if (yych == 'n') goto yy697;
			goto yy46;
		}
	}
yy665:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy679;
					if (yych <= '/') goto yy676;
					goto yy665;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '@') {
					if (yych == ';') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'C') goto yy667;
					if (yych <= 'F') goto yy680;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy681;
					if (yych <= 'R') goto yy46;
					goto yy681;
				} else {
					if (yych == '[') goto yy618;
					if (yych <= '\\') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 'r') {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					if (yych >= 'd') goto yy680;
				} else {
					if (yych == 'l') goto yy681;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 's') goto yy681;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x000000A0) goto yy618;
					if (yych <= 0x0000167F) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy667:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '.') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '/') goto yy676;
					goto yy667;
				} else {
					if (yych == ';') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'F') goto yy667;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy667;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy669:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy670:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= ':') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy670;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy618;
					if (yych <= 'C') goto yy46;
				} else {
					if (yych != 'L') goto yy46;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'S') goto yy672;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy672;
					if (yych <= 'k') goto yy46;
				} else {
					if (yych != 's') goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy672:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy673;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy674;
		goto yy46;
	}
yy673:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy674:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy674;
				if (yych <= ':') goto yy46;
				goto yy618;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy676:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy677;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy677:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ':') {
					if (yych <= '9') goto yy677;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych <= '@') goto yy46;
					goto yy677;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= 'f') goto yy677;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x0000180E) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy618;
					if (yych <= 0x0000202E) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy679:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy688;
			if (yych <= 'F') goto yy689;
			goto yy688;
		} else {
			if (yych <= 'L') goto yy689;
			if (yych <= 'R') goto yy688;
			goto yy689;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy688;
			if (yych <= 'f') goto yy689;
			goto yy688;
		} else {
			if (yych <= 'l') goto yy689;
			if (yych == 's') goto yy689;
			goto yy688;
		}
	}
yy680:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy682;
	if (yych == '-') goto yy682;
	goto yy686;
yy681:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy682;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy683;
		goto yy46;
	}
yy682:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy683:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy683;
				if (yych <= ':') goto yy46;
				goto yy618;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy685:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy686:
	if (yych <= ']') {
		if (yych <= '.') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '/') goto yy676;
					goto yy685;
				} else {
					if (yych == ';') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'F') goto yy667;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy667;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy687:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy688:
	if (yych <= 'c') {
		if (yych <= ':') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy687;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'F') {
					if (yych <= ';') goto yy618;
					if (yych <= 'C') goto yy46;
					goto yy693;
				} else {
					if (yych == 'L') goto yy693;
					goto yy46;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'S') goto yy693;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy693;
					if (yych <= 'k') goto yy46;
					goto yy693;
				} else {
					if (yych == 's') goto yy693;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy689:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy690;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy691;
		goto yy46;
	}
yy690:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy691:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy691;
				if (yych <= ':') goto yy46;
				goto yy618;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy693:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy694;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy695;
		goto yy46;
	}
yy694:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy695:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy46;
				if (yych <= '9') goto yy695;
				if (yych <= ':') goto yy46;
				goto yy618;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy618;
				} else {
					if (yych == ']') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy697:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy702;
	goto yy46;
yy698:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy632;
	goto yy46;
yy702:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy632;
	goto yy46;
yy705:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy706:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy621;
					goto yy46;
				} else {
					if (yych <= '-') goto yy621;
					if (yych <= '/') goto yy46;
					goto yy706;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy618;
					goto yy46;
				} else {
					if (yych <= '@') goto yy620;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy708:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy709;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy709:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy621;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy709;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych <= 'F') goto yy709;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy709;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy711:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy723;
			if (yych <= 'F') goto yy724;
			goto yy723;
		} else {
			if (yych <= 'L') goto yy724;
			if (yych <= 'R') goto yy723;
			goto yy724;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy723;
			if (yych <= 'f') goto yy724;
			goto yy723;
		} else {
			if (yych <= 'l') goto yy724;
			if (yych == 's') goto yy724;
			goto yy723;
		}
	}
yy712:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy719;
	if (yych == '-') goto yy719;
	goto yy718;
yy713:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy714;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy715;
		goto yy46;
	}
yy714:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy715:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy621;
					goto yy46;
				} else {
					if (yych <= '-') goto yy621;
					if (yych <= '/') goto yy46;
					goto yy715;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy618;
					goto yy46;
				} else {
					if (yych <= '@') goto yy620;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy717:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy718:
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych == '-') goto yy621;
					goto yy46;
				} else {
					if (yych <= '/') goto yy708;
					if (yych <= '9') goto yy717;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych <= 'F') goto yy612;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy612;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy719:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy628;
			goto yy46;
		} else {
			if (yych <= '9') goto yy720;
			if (yych <= '@') goto yy46;
			goto yy626;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy626;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy622;
			if (yych == 'n') goto yy623;
			goto yy46;
		}
	}
yy720:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy639;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy636;
					if (yych <= '9') goto yy720;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
					goto yy626;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy640;
					if (yych == 'L') goto yy641;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy641;
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
					goto yy626;
				} else {
					if (yych <= 'f') goto yy640;
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy641;
					if (yych <= 'r') goto yy46;
					goto yy641;
				} else {
					if (yych == 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy618;
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy722:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy723:
	if (yych <= '[') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych == '+') goto yy621;
					if (yych <= ',') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy722;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych == '@') goto yy620;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy728;
					if (yych <= 'K') goto yy46;
					goto yy728;
				} else {
					if (yych == 'S') goto yy728;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'c') {
					if (yych == ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy728;
					if (yych <= 'k') goto yy46;
					goto yy728;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy728;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy724:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy725;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy726;
		goto yy46;
	}
yy725:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy726:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy621;
					goto yy46;
				} else {
					if (yych <= '-') goto yy621;
					if (yych <= '/') goto yy46;
					goto yy726;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy618;
					goto yy46;
				} else {
					if (yych <= '@') goto yy620;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy728:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy729;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy730;
		goto yy46;
	}
yy729:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy730:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= ',') {
					if (yych <= '+') goto yy621;
					goto yy46;
				} else {
					if (yych <= '-') goto yy621;
					if (yych <= '/') goto yy46;
					goto yy730;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy618;
					goto yy46;
				} else {
					if (yych <= '@') goto yy620;
					if (yych <= 'Z') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy732:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy618;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy618;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy618;
					goto yy46;
				} else {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych == ';') goto yy618;
				if (yych <= 'Z') goto yy46;
				goto yy618;
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy618;
				} else {
					if (yych == 'n') goto yy773;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy618;
				if (yych == 0x000000A0) goto yy618;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy618;
				if (yych <= 0x0000202E) goto yy46;
				goto yy618;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy733:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy769;
	goto yy46;
yy734:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy748;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy745;
					if (yych <= '9') goto yy734;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy749;
					if (yych == 'L') goto yy750;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy750;
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
				} else {
					if (yych <= 'f') goto yy749;
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy750;
					if (yych <= 'r') goto yy46;
					goto yy750;
				} else {
					if (yych == 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy618;
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy736:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych == '+') goto yy621;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy621;
					if (yych <= '.') goto yy46;
					goto yy745;
				} else {
					if (yych <= '9') goto yy736;
					if (yych <= ':') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
					goto yy736;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
					goto yy736;
				} else {
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy738:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy739:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy739;
					if (yych <= ':') goto yy46;
					goto yy618;
				} else {
					if (yych == '@') goto yy620;
					if (yych <= 'C') goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych != 'L') goto yy46;
				} else {
					if (yych <= 'S') goto yy741;
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy618;
					if (yych <= 'c') goto yy46;
				} else {
					if (yych == 'i') goto yy632;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy741:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy742;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy743;
		goto yy46;
	}
yy742:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy743:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy621;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy743;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy632;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy745:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy746;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy746:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '-') goto yy621;
					goto yy46;
				} else {
					if (yych <= '9') goto yy746;
					if (yych <= ':') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
					goto yy746;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
					goto yy746;
				} else {
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy748:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy760;
			if (yych <= 'F') goto yy761;
			goto yy760;
		} else {
			if (yych <= 'L') goto yy761;
			if (yych <= 'R') goto yy760;
			goto yy761;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy760;
			if (yych <= 'f') goto yy761;
			goto yy760;
		} else {
			if (yych <= 'l') goto yy761;
			if (yych == 's') goto yy761;
			goto yy760;
		}
	}
yy749:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy756;
	if (yych == '-') goto yy756;
	goto yy755;
yy750:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy751;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy752;
		goto yy46;
	}
yy751:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy752:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy621;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy752;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy632;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy754:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy755:
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy618;
					if (yych <= '\'') goto yy46;
					goto yy618;
				} else {
					if (yych == '+') goto yy621;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy621;
					if (yych <= '.') goto yy46;
					goto yy745;
				} else {
					if (yych <= '9') goto yy754;
					if (yych <= ':') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
					goto yy736;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
					goto yy736;
				} else {
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy756:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy628;
			goto yy46;
		} else {
			if (yych <= '9') goto yy757;
			if (yych <= '@') goto yy46;
			goto yy626;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy626;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy622;
			if (yych == 'n') goto yy623;
			goto yy46;
		}
	}
yy757:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy639;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy636;
					if (yych <= '9') goto yy757;
					goto yy46;
				} else {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy620;
					goto yy626;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy640;
					if (yych == 'L') goto yy641;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy641;
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy618;
					if (yych <= '`') goto yy46;
					goto yy626;
				} else {
					if (yych <= 'f') goto yy640;
					if (yych == 'i') goto yy632;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy641;
					if (yych <= 'r') goto yy46;
					goto yy641;
				} else {
					if (yych == 0x00000085) goto yy618;
					if (yych <= 0x0000009F) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy618;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy618;
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy759:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy760:
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy618;
					if (yych <= 0x00000008) goto yy46;
					goto yy618;
				} else {
					if (yych == ' ') goto yy618;
					if (yych <= '!') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy621;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych <= '9') goto yy759;
					if (yych <= ':') goto yy46;
					goto yy618;
				} else {
					if (yych == '@') goto yy620;
					if (yych <= 'C') goto yy46;
					goto yy765;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy765;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy765;
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy618;
					if (yych <= 'c') goto yy46;
					goto yy765;
				} else {
					if (yych == 'i') goto yy632;
					if (yych <= 'k') goto yy46;
					goto yy765;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy765;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy618;
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy618;
					if (yych <= 0x00002027) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy618;
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy761:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy762;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy763;
		goto yy46;
	}
yy762:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy763:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy621;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy763;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy632;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy765:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy766;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy767;
		goto yy46;
	}
yy766:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy767:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy618;
					goto yy46;
				} else {
					if (yych <= ')') goto yy618;
					if (yych <= '*') goto yy46;
					goto yy621;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy621;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy767;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy618;
					if (yych <= '?') goto yy46;
					goto yy620;
				} else {
					if (yych == '[') goto yy618;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy618;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy632;
					if (yych <= 0x00000084) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy769:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy772:
	yych = *++YYCURSOR;
	if (yych <= ']') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy618;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy618;
					if (yych <= 0x0000001F) goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy618;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy618;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= ',') {
					if (yych <= '+') goto yy621;
					goto yy46;
				} else {
					if (yych <= '-') goto yy621;
					if (yych <= ':') goto yy46;
					goto yy618;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy620;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy618;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'i') {
					if (yych <= 'h') goto yy46;
					goto yy632;
				} else {
					if (yych == 0x00000085) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy618;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy618;
					if (yych <= 0x0000180D) goto yy46;
					goto yy618;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy618;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy618;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy618;
					if (yych <= 0x0000205E) goto yy46;
					goto yy618;
				} else {
					if (yych == 0x00003000) goto yy618;
					goto yy46;
				}
			}
		}
	}
yy773:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy772;
	goto yy46;
yy776:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy608;
		if (yych <= 'H') goto yy46;
		goto yy608;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy608;
		} else {
			if (yych == 'i') goto yy608;
			goto yy46;
		}
	}
yy777:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '/') goto yy782;
	if (yych == '\\') goto yy777;
	goto yy358;
yy779:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy780;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy780;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy780;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy780;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy780;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy780;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy780:
	++YYCURSOR;
yy781:
#line 410 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN + 2, (YYCURSOR - YYTOKEN) - 3);
            YYTOKEN = YYCURSOR;
            return REGEXP;
        }
#line 16655 "<stdout>"
yy782:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy783;
				if (yych <= 0x00000008) goto yy358;
				if (yych >= 0x0000000E) goto yy358;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy358;
				} else {
					if (yych <= '#') goto yy783;
					if (yych <= '\'') goto yy358;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '/') goto yy779;
				if (yych <= ':') goto yy358;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy358;
				} else {
					if (yych <= '\\') goto yy777;
					if (yych >= '^') goto yy358;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy783;
				if (yych != 0x000000A0) goto yy358;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy358;
				} else {
					if (yych <= 0x0000180E) goto yy783;
					if (yych <= 0x00001FFF) goto yy358;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy358;
				if (yych <= 0x00002029) goto yy783;
				if (yych <= 0x0000202E) goto yy358;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy358;
				} else {
					if (yych != 0x00003000) goto yy358;
				}
			}
		}
	}
yy783:
	yyaccept = 5;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy779;
	if (yych == '\\') goto yy777;
	goto yy358;
yy784:
	++YYCURSOR;
#line 445 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_SYNTAX; }
#line 16729 "<stdout>"
yy786:
	++YYCURSOR;
#line 449 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASISYNTAX; }
#line 16737 "<stdout>"
yy788:
	++YYCURSOR;
#line 453 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAX;
        }
#line 16746 "<stdout>"
yy790:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 458 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAXSPLICING;
        }
#line 16756 "<stdout>"
yy793:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy794:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy799;
			goto yy793;
		} else {
			if (yych <= '\n') goto yy799;
			if (yych <= '\f') goto yy793;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy793;
			goto yy798;
		} else {
			if (yych == 0x00002028) goto yy798;
			goto yy793;
		}
	}
yy795:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= '!') {
			if (yych <= '\n') {
				if (yych <= 0x00000000) goto yy802;
				if (yych <= 0x00000008) goto yy793;
				if (yych <= '\t') goto yy803;
				goto yy802;
			} else {
				if (yych <= '\r') {
					if (yych <= '\f') goto yy803;
					goto yy804;
				} else {
					if (yych == ' ') goto yy803;
					goto yy793;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '\'') {
					if (yych <= '#') goto yy803;
					goto yy793;
				} else {
					if (yych <= ')') goto yy803;
					if (yych <= ':') goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy793;
					goto yy803;
				} else {
					if (yych == ']') goto yy803;
					goto yy793;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy806;
				if (yych == 0x000000A0) goto yy803;
				goto yy793;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy803;
					goto yy793;
				} else {
					if (yych <= 0x0000180E) goto yy803;
					if (yych <= 0x00001FFF) goto yy793;
					goto yy803;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy793;
					goto yy806;
				} else {
					if (yych <= 0x00002029) goto yy803;
					if (yych <= 0x0000202E) goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy793;
					goto yy803;
				} else {
					if (yych == 0x00003000) goto yy803;
					goto yy793;
				}
			}
		}
	}
yy796:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\f') {
			if (yych <= 0x00000000) goto yy799;
			if (yych == '\n') goto yy799;
			goto yy793;
		} else {
			if (yych <= ',') {
				if (yych <= '\r') goto yy795;
				goto yy793;
			} else {
				if (yych <= '9') goto yy796;
				if (yych <= '@') goto yy793;
				goto yy796;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych == '_') goto yy796;
			if (yych <= '`') goto yy793;
			goto yy796;
		} else {
			if (yych <= 0x00000085) {
				if (yych <= 0x00000084) goto yy793;
			} else {
				if (yych != 0x00002028) goto yy793;
			}
		}
	}
yy798:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= '!') {
			if (yych <= '\n') {
				if (yych <= 0x00000000) goto yy802;
				if (yych <= 0x00000008) goto yy793;
				if (yych <= '\t') goto yy803;
				goto yy802;
			} else {
				if (yych <= '\r') {
					if (yych <= '\f') goto yy803;
					goto yy804;
				} else {
					if (yych == ' ') goto yy803;
					goto yy793;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '\'') {
					if (yych <= '#') goto yy803;
					goto yy793;
				} else {
					if (yych <= ')') goto yy803;
					if (yych <= ':') goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy793;
					goto yy803;
				} else {
					if (yych == ']') goto yy803;
					goto yy793;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy806;
				if (yych == 0x000000A0) goto yy803;
				goto yy793;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy803;
					goto yy793;
				} else {
					if (yych <= 0x0000180E) goto yy803;
					if (yych <= 0x00001FFF) goto yy793;
					goto yy803;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy793;
					goto yy806;
				} else {
					if (yych <= 0x00002029) goto yy803;
					if (yych <= 0x0000202E) goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy793;
					goto yy803;
				} else {
					if (yych == 0x00003000) goto yy803;
					goto yy793;
				}
			}
		}
	}
yy799:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy800;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych == '!') goto yy46;
				if (yych >= '$') goto yy46;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy800;
				if (yych != ';') goto yy46;
			} else {
				if (yych <= '\\') {
					if (yych >= '\\') goto yy46;
				} else {
					if (yych <= ']') goto yy800;
					if (yych <= 0x00000084) goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy800;
				if (yych <= 0x0000167F) goto yy46;
			} else {
				if (yych == 0x0000180E) goto yy800;
				if (yych <= 0x00001FFF) goto yy46;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy800;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy800:
	++YYCURSOR;
yy801:
#line 235 "src/scanner.re"
	{
            YYCURSOR--;
            ucs4string shebang(YYTOKEN, YYCURSOR - YYTOKEN - 1);
            if (shebang == ucs4string(UC("#!r6rs"))) {
                currentVM()->readerContext()->port()->setStrictR6RsReaderMode();
            } else {
                 // just ignore the shebang.
            }
            YYTOKEN = YYCURSOR;
            continue;
       }
#line 17029 "<stdout>"
yy802:
	yych = *++YYCURSOR;
	if (yych <= 0x00000085) {
		if (yych <= '\'') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy800;
				if (yych <= 0x00000008) goto yy801;
				if (yych <= '\r') goto yy800;
				goto yy801;
			} else {
				if (yych == '!') goto yy801;
				if (yych <= '#') goto yy800;
				goto yy801;
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= ')') goto yy800;
				if (yych == ';') goto yy800;
				goto yy801;
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy800;
					goto yy801;
				} else {
					if (yych <= ']') goto yy800;
					if (yych <= 0x00000084) goto yy801;
					goto yy800;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x00001680) {
				if (yych == 0x000000A0) goto yy800;
				if (yych <= 0x0000167F) goto yy801;
				goto yy800;
			} else {
				if (yych == 0x0000180E) goto yy800;
				if (yych <= 0x00001FFF) goto yy801;
				goto yy800;
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy801;
				if (yych <= 0x00002029) goto yy800;
				if (yych <= 0x0000202E) goto yy801;
				goto yy800;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy801;
					goto yy800;
				} else {
					if (yych == 0x00003000) goto yy800;
					goto yy801;
				}
			}
		}
	}
yy803:
	yyaccept = 6;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy799;
			goto yy793;
		} else {
			if (yych <= '\n') goto yy799;
			if (yych <= '\f') goto yy793;
			goto yy795;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy793;
			goto yy798;
		} else {
			if (yych == 0x00002028) goto yy798;
			goto yy793;
		}
	}
yy804:
	yyaccept = 6;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= '!') {
			if (yych <= '\n') {
				if (yych <= 0x00000000) goto yy802;
				if (yych <= 0x00000008) goto yy793;
				if (yych <= '\t') goto yy803;
				goto yy802;
			} else {
				if (yych <= '\r') {
					if (yych <= '\f') goto yy803;
					goto yy804;
				} else {
					if (yych == ' ') goto yy803;
					goto yy793;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '\'') {
					if (yych <= '#') goto yy803;
					goto yy793;
				} else {
					if (yych <= ')') goto yy803;
					if (yych <= ':') goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy793;
					goto yy803;
				} else {
					if (yych == ']') goto yy803;
					goto yy793;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy806;
				if (yych == 0x000000A0) goto yy803;
				goto yy793;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy803;
					goto yy793;
				} else {
					if (yych <= 0x0000180E) goto yy803;
					if (yych <= 0x00001FFF) goto yy793;
					goto yy803;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy793;
				} else {
					if (yych <= 0x00002029) goto yy803;
					if (yych <= 0x0000202E) goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy793;
					goto yy803;
				} else {
					if (yych == 0x00003000) goto yy803;
					goto yy793;
				}
			}
		}
	}
yy806:
	yyaccept = 6;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= '!') {
			if (yych <= '\n') {
				if (yych <= 0x00000000) goto yy802;
				if (yych <= 0x00000008) goto yy793;
				if (yych <= '\t') goto yy803;
				goto yy802;
			} else {
				if (yych <= '\r') {
					if (yych <= '\f') goto yy803;
					goto yy804;
				} else {
					if (yych == ' ') goto yy803;
					goto yy793;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '\'') {
					if (yych <= '#') goto yy803;
					goto yy793;
				} else {
					if (yych <= ')') goto yy803;
					if (yych <= ':') goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy793;
					goto yy803;
				} else {
					if (yych == ']') goto yy803;
					goto yy793;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy806;
				if (yych == 0x000000A0) goto yy803;
				goto yy793;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy803;
					goto yy793;
				} else {
					if (yych <= 0x0000180E) goto yy803;
					if (yych <= 0x00001FFF) goto yy793;
					goto yy803;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy793;
					goto yy806;
				} else {
					if (yych <= 0x00002029) goto yy803;
					if (yych <= 0x0000202E) goto yy793;
					goto yy803;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy793;
					goto yy803;
				} else {
					if (yych == 0x00003000) goto yy803;
					goto yy793;
				}
			}
		}
	}
yy808:
	yych = *++YYCURSOR;
	if (yych != '(') goto yy46;
	++YYCURSOR;
#line 481 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return BYTE_VECTOR_START;
        }
#line 17275 "<stdout>"
yy811:
	yych = *++YYCURSOR;
	if (yych != '8') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '(') goto yy46;
	++YYCURSOR;
#line 485 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return BYTE_VECTOR_START;
        }
#line 17287 "<stdout>"
}
#line 510 "src/scanner.re"


comment:
        YYTOKEN = YYCURSOR;

#line 17295 "<stdout>"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '#') {
		if (yych <= 0x00000000) goto yy820;
		if (yych <= '"') goto yy822;
		goto yy819;
	} else {
		if (yych != '|') goto yy822;
	}
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '#') goto yy825;
yy818:
#line 532 "src/scanner.re"
	{
            goto comment;
        }
#line 17314 "<stdout>"
yy819:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy823;
	goto yy818;
yy820:
	++YYCURSOR;
#line 527 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return 0;
        }
#line 17326 "<stdout>"
yy822:
	yych = *++YYCURSOR;
	goto yy818;
yy823:
	++YYCURSOR;
#line 523 "src/scanner.re"
	{
            comment_count++;
            goto comment;
        }
#line 17337 "<stdout>"
yy825:
	++YYCURSOR;
#line 515 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            if (--comment_count == 0) {
                continue;
            } else {
                goto comment;
            }
        }
#line 17349 "<stdout>"
}
#line 535 "src/scanner.re"

    }
}

ucs4string Scanner::currentToken() const
{
    if (limit_ >= token_) {
        return ucs4string(token_, limit_ - token_);
    } else {
        return ucs4string(UC(""));
    }
}
